package com.unissoft.equipmentStroe.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.unissoft.equipmentStroe.service.EquipmentStroeService;
import com.unissoft.model.EquipmentStroe;
import com.unissoft.result.PageParam;
import com.unissoft.result.ResultView;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author root
 * @since 2020-12-15
 */
@Api(description = "器材库")
@RestController
@RequestMapping("/equipmentStroe")
public class EquipmentStroeController {

    @Autowired
    private EquipmentStroeService quipmentStroeServicee;

    @ApiOperation(value = "分页条件查询",
            notes = "提交参数：{\"pageIndex\":1,\"pageSize\":10,\"," +
                    "\"condition\":\"{'table_name':'equipment_stroe'," +
                    "'field_name':'check_list'\"}")
    @PostMapping("/authority/getPage")
    public ResultView getPage(@RequestBody PageParam pageParam) {
        Page<EquipmentStroe> page = quipmentStroeServicee.getPage(pageParam);
        return ResultView.success(page);
    }

    @ApiOperation(value = "新增", notes = "")
    @PostMapping("/authority_button/add")
    public ResultView add(@RequestBody EquipmentStroe model) {
        quipmentStroeServicee.save(model);
        return ResultView.success(model);
    }

    @ApiOperation(value = "修改", notes = "")
    @PostMapping("/authority_button/update")
    public ResultView update(@RequestBody EquipmentStroe model) {
        quipmentStroeServicee.updateById(model);
        return ResultView.success(model);
    }

    @ApiOperation(value = "根据id删除", notes = "")
    @DeleteMapping("/authority_button/deleteById/{id}")
    public ResultView deleteById(@PathVariable Integer id) {
        quipmentStroeServicee.deleteById(id);
        return ResultView.success();
    }

    @ApiOperation(value = "根据id查询", notes = "")
    @PostMapping("/authority_button/getOne/{id}")
    public ResultView getOne(@PathVariable Integer id) {
        EquipmentStroe equipmentStroe = quipmentStroeServicee.getById(id);
        return ResultView.success(equipmentStroe);
    }

}
