package com.unissoft.equipmentStroe.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.unissoft.MyConstant;
import com.unissoft.equipmentStroe.service.EquipmentStroeService;
import com.unissoft.mapper.EquipmentStroeMapper;
import com.unissoft.model.EquipmentStroe;
import com.unissoft.result.PageParam;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author root
 * @since 2020-12-15
 */
@Service
public class EquipmentStroeServiceImpl extends ServiceImpl<EquipmentStroeMapper, EquipmentStroe> implements EquipmentStroeService {

    @Autowired
    private EquipmentStroeMapper equipmentStroeMapper;

    @Override
    public Page<EquipmentStroe> getPage(PageParam pageParam) {
        int pageIndex = pageParam.getPageIndex();
        int pageSize = pageParam.getPageSize();
        QueryWrapper<EquipmentStroe> ew = new QueryWrapper<>();
        if (!StringUtils.isEmpty(pageParam.getCondition())) {
            JSONObject object = new JSONObject(pageParam.getCondition());
            String depotId = object.optString("depot_id").trim();
            String assetNumber = object.optString("asset_number").trim();
            String equipmentCategory = object.optString("equipment_category").trim();
            String equipmentNameCode = object.optString("equipment_name_code").trim();
            String standardsType = object.optString("standards_type").trim();
            String arrivalTime = object.optString("arrival_time").trim();
            String state = object.optString("state").trim();
            if (!StringUtils.isEmpty(depotId)) {
                ew.eq("depot_id", depotId);
            }
            if (!StringUtils.isEmpty(assetNumber)) {
                ew.like("asset_number", assetNumber);
            }
            if (!StringUtils.isEmpty(equipmentCategory)) {
                ew.eq("equipment_category", equipmentCategory);
            }
            if (!StringUtils.isEmpty(equipmentNameCode)) {
                ew.eq("equipment_name_code", equipmentNameCode);
            }
            if (!StringUtils.isEmpty(standardsType)) {
                ew.eq("standards_type", standardsType);
            }
            if (!StringUtils.isEmpty(state)) {
                ew.eq("state", state);
            }
        }
        ew.orderByDesc("arrival_time");
        Page page = new Page();
        if (pageIndex != MyConstant.ZERO && pageSize != MyConstant.ZERO) {
            page = new Page(pageIndex, pageSize);
        }
        Page<EquipmentStroe> pageResult = equipmentStroeMapper.selectPage(page, ew);
        return pageResult;
    }


    @Override
    public void deleteById(Integer id) {
        equipmentStroeMapper.deleteById(id);
    }
}
