package com.unissoft.facilities.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.unissoft.model.EquipFacilities;
import com.unissoft.model.EquipFacilitiesBase;
import com.unissoft.result.PageParam;

import java.util.List;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author root
 * @since 2021-01-25
 */
public interface EquipFacilitiesService extends IService<EquipFacilities> {

    /**
     * 获取 最新设施检查记录
     *
     * @param model
     * @return
     */
    List<EquipFacilities> getLastFacilitiesList(EquipFacilities model);

    /**
     * 同时保存主表,子表信息
     *
     * @param model
     * @return
     */
    boolean savePrimeAndChildren(EquipFacilitiesBase model);

    /**
     * 全部设施检查记录分页数据
     *
     * @param pageParam
     * @return
     */
    IPage<EquipFacilities> getPageInfo(PageParam pageParam);

    /**
     * 根据id删除主表及子表数据(关联子表pId)
     * @param id
     * @return
     */
    boolean deleteById(Integer id);

    boolean updatePrimeAndChildren(EquipFacilitiesBase model);
}
