package com.unissoft.feign;

import com.unissoft.MyConstant;
import com.unissoft.dto.MessageVO;
import com.unissoft.dto.SendNoticeVO;
import com.unissoft.result.ResultView;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;


/**
 * feign调用system-manage服务
 */
@FeignClient(value = MyConstant.CSC_SZLS_MESSAGE, fallback = MessageHystrix.class)
@Component
public interface MessageFeign {

	@PostMapping("/sysNoticeUser/authority_button/sendNotice")
	ResultView sendNotice(@RequestBody SendNoticeVO sendNoticeVO);

	/**
	 * 向用户发送信息
	 * @param messageVO
	 * @return
	 */
	@PostMapping("/sysMessage/authority/sendMessage")
	ResultView sendMessage(@RequestBody MessageVO messageVO);

}
