package com.unissoft.feign;

import com.unissoft.dto.MessageVO;
import com.unissoft.dto.SendNoticeVO;
import com.unissoft.result.ResultView;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;


/**
 * 熔断器
 */
@Component
public class MessageHystrix implements MessageFeign {

    private final Logger logger = LoggerFactory.getLogger(MessageHystrix.class);

    @Override
    public ResultView sendNotice(SendNoticeVO sendNoticeVO) {
        // TODO Auto-generated method stub
		System.err.println("调用csc-szls-message(sendNotice方法)服务发送通知失败!");
        logger.error("调用csc-szls-message(sendNotice方法)服务发送通知失败!");
        return null;
    }

    @Override
    public ResultView sendMessage(MessageVO messageVO) {
        System.err.println("调用csc-szls-message(sendMessage方法)服务向用户发送信息失败!");
        logger.error("调用csc-szls-message(sendMessage方法)服务向用户发送信息失败!");
        return null;
    }

}
