package com.unissoft.feign;

import com.unissoft.MyConstant;
import com.unissoft.model.BasicsWarehouse;
import com.unissoft.model.SysUserDTO;
import com.unissoft.result.ResultView;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.HashMap;
import java.util.List;


/**
 * feign调用system-manage服务
 */
@FeignClient(value = MyConstant.CSC_SZLS_UPMS_SYSTEM_MANAGE, fallback = SystemHystrix.class)
@Component
public interface SystemFeign {

    @GetMapping(value = "/basicsWarehouse/authority/getByIdHouse")
    BasicsWarehouse getByIdHouse(@RequestParam("id") Integer id);

    @GetMapping("/user/authority/getUserById/{id}")
    SysUserDTO getUserById(@PathVariable("id") Integer id);

    @GetMapping("/user/authority/getByUserAll")
    HashMap<Integer, SysUserDTO> getByUserAll();

    @GetMapping("/user/authority/getAll")
    ResultView getAll(@RequestParam("depotId") Integer depotId);

    @GetMapping("/basicsDepot/authority/getAllLONAndLAT")
    ResultView getAllLONAndLAT(@RequestParam("homeType") Integer homeType, @RequestParam("depotId") Integer depotId);

    @GetMapping("/basicsDepot/authority/getAllDepotChild")
    List<Integer> getAllDepotChild(@RequestParam("depotId") Integer depotId);

    @GetMapping("/basicsDepot/authority/getAllMAP")
    ResultView getAllMAP(@RequestParam("depotId") Integer depotId);

    @GetMapping("/basicsDepot/authority/getItselfJoinDownDepotId/{depotId}")
    ResultView getItselfJoinDownDepotId(@PathVariable("depotId") Integer depotId);

}
