package com.unissoft.feign;

import com.unissoft.model.BasicsWarehouse;
import com.unissoft.model.SysUserDTO;
import com.unissoft.result.ResultView;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;


/**
 * 熔断器
 */
@Component
public class SystemHystrix implements SystemFeign {

    private final Logger logger = LoggerFactory.getLogger(SystemHystrix.class);

    @Override
    public BasicsWarehouse getByIdHouse(Integer id) {
        // TODO Auto-generated method stub
        logger.error("调用csc-szls-system-manage(getById方法)服务根据id查询仓房信息失败!");
        return null;
    }

    @Override
    public SysUserDTO getUserById(Integer id) {
        // TODO Auto-generated method stub
        logger.error("调用csc-szls-system-manage(getById方法)服务根据id查询用户信息失败!");
        return null;
    }

    @Override
    public HashMap<Integer, SysUserDTO> getByUserAll() {
        // TODO Auto-generated method stub
        logger.error("调用csc-szls-system-manage(getByUserAll方法)服务查询所有用户信息失败!");
        return null;
    }

    @Override
    public ResultView getAll(Integer depotId) {
        // TODO Auto-generated method stub
        logger.error("调用csc-szls-system-manage(getAll方法)服务根据id查询用户信息失败!");
        return null;
    }

    @Override
    public ResultView getAllLONAndLAT(Integer homeType, Integer depotId) {
        logger.error("调用csc-szls-system-manage(getAllLONAndLAT方法)服务根据id查询用户信息失败!");
        return ResultView.hystrixError("getAllLONAndLAT方法");
    }

    @Override
    public List<Integer> getAllDepotChild(Integer depotId) {
        logger.error("调用csc-szls-system-manage(getAllDepotChild方法)获取库点自己和所有子集id集合失败!");
        return null;
    }

    @Override
    public ResultView getAllMAP(Integer depotId) {
        logger.error("调用csc-szls-system-manage(getAllMAP方法)获取库点MAP失败!");
        return ResultView.hystrixError("getAllMAP方法");
    }


	@Override
	public ResultView getItselfJoinDownDepotId(Integer depotId) {
		logger.error("调用csc-szls-system-manage(getItselfJoinDownDepotId方法)服务根据id查询用户信息失败!");
		return ResultView.hystrixError("getItselfJoinDownDepotId方法");
	}

}
