package com.unissoft.grainManage.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.unissoft.grainManage.service.GrainSecurityInspectService;
import com.unissoft.model.GrainSecurityInspect;
import com.unissoft.model.SysUserPO;
import com.unissoft.result.PageParam;
import com.unissoft.result.ResultView;
import com.unissoft.utils.UserUtils;
import com.unissoft.vo.GrainSecurityInspectVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 * 安全巡查 前端控制器
 * </p>
 *
 * @author root
 * @since 2021-01-18
 */
@Api(description = "安全巡查")
@RestController
@RequestMapping("/grainSecurityInspect")
public class GrainSecurityInspectController {

    @Autowired
    private GrainSecurityInspectService securityInspectService;

    @ApiOperation(value = "查询最新数据", notes = "提交参数：")
    @PostMapping("/authority/getEveryTypeNewData/{depotId}")
    public ResultView getEveryTypeNewData(@PathVariable("depotId") Integer depotId) {
        List<GrainSecurityInspect> result = securityInspectService.getEveryTypeNewData(depotId);
        return ResultView.success(result);
    }

    @ApiOperation(value = "分页条件查询", notes = "提交参数：{\n" +
            "  \"condition\":\"{'inspecTimeStart':'','inspecTimeEnd':'', 'inspecType':'', 'status':''}\",\n" +
            "  \"pageIndex\": 1,\n" +
            "  \"pageSize\": 10\n" +
            "}")
    @PostMapping("/authority/getAllPage/{depotId}")
    public ResultView getAllPage(@PathVariable("depotId") Integer depotId, @RequestBody PageParam pageParam) {
        Page<GrainSecurityInspect> page = securityInspectService.getAllPage(depotId, pageParam);
        return ResultView.success(page);
    }

    @ApiOperation(value = "根据id查询", notes = "")
    @GetMapping("/authority/getDataById/{id}")
    public ResultView getDataById(@PathVariable int id) {
        GrainSecurityInspectVO result = securityInspectService.getDataById(id);
        return ResultView.success(result);
    }

    @ApiOperation(value = "新增或修改", notes = "")
    @PostMapping("/authority_button/saveOrUpdateData")
    public ResultView saveOrUpdateData(@RequestBody GrainSecurityInspectVO model) {
        SysUserPO userPO = UserUtils.getCurrUserInfo();
        securityInspectService.saveOrUpdateData(model, userPO);
        return ResultView.success(model);
    }


    @ApiOperation(value = "根据id删除", notes = "")
    @DeleteMapping("/authority_button/deleteById/{id}")
    public ResultView deleteById(@PathVariable int id) {
        securityInspectService.deleteById(id);
        return ResultView.success();
    }

}
