package com.unissoft.grainManage.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.unissoft.grainManage.service.GrainSecurityInspectDetailsService;
import com.unissoft.mapper.GrainSecurityInspectDetailsMapper;
import com.unissoft.model.GrainSecurityInspectDetails;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 安全巡查细节 服务实现类
 * </p>
 *
 * @author root
 * @since 2021-01-18
 */
@Service
public class GrainSecurityInspectDetailsServiceImpl extends ServiceImpl<GrainSecurityInspectDetailsMapper, GrainSecurityInspectDetails> implements GrainSecurityInspectDetailsService {

    @Autowired
    private GrainSecurityInspectDetailsMapper grainSecurityInspectDetailsMapper;

    @Override
    public List<GrainSecurityInspectDetails> getByPid(Integer pid) {
        QueryWrapper<GrainSecurityInspectDetails> ew = new QueryWrapper<>();
        ew.eq("pid", pid);
        ew.orderByAsc("orderby");
        List<GrainSecurityInspectDetails> list = grainSecurityInspectDetailsMapper.selectList(ew);
        return list;
    }

    @Override
    public void deleteByPid(Integer pid) {
        QueryWrapper<GrainSecurityInspectDetails> ew = new QueryWrapper<>();
        ew.eq("pid", pid);
        grainSecurityInspectDetailsMapper.delete(ew);
    }


}
