package com.unissoft.inspection.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.unissoft.inspection.service.BranchDepotInspectService;
import com.unissoft.model.BranchDepotInspect;
import com.unissoft.model.SysUserPO;
import com.unissoft.result.PageParam;
import com.unissoft.result.ResultView;
import com.unissoft.utils.UserUtils;
import com.unissoft.vo.BranchDepotInspectVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 * 分库检查 前端控制器
 * </p>
 *
 * @author root
 * @since 2021-01-27
 */
@Api(description = "分库检查")
@RestController
@RequestMapping("/branchDepotInspect")
public class BranchDepotInspectController {

    @Autowired
    private BranchDepotInspectService branchDepotInspectService;

    @ApiOperation(value = "分页条件查询", notes = "提交参数：{\n" +
            "  \"condition\":\"{'inspecTimeStart':'','inspecTimeEnd':'', 'status':''}\",\n" +
            "  \"pageIndex\": 1,\n" +
            "  \"pageSize\": 10\n" +
            "}")
    @PostMapping("/authority/getAllPage/{depotId}")
    public ResultView getAllPage(@PathVariable("depotId") Integer depotId, @RequestBody PageParam pageParam) {
        Page<BranchDepotInspect> page = branchDepotInspectService.getAllPage(depotId, pageParam);
        return ResultView.success(page);
    }

    @ApiOperation(value = "根据id查询", notes = "")
    @GetMapping("/authority/getDataById/{id}")
    public ResultView getDataById(@PathVariable int id) {
        BranchDepotInspectVO result = branchDepotInspectService.getDataById(id);
        return ResultView.success(result);
    }

    @ApiOperation(value = "新增或修改", notes = "")
    @PostMapping("/authority_button/saveOrUpdateData")
    public ResultView saveOrUpdateData(@RequestBody BranchDepotInspectVO model) {
        SysUserPO userPO = UserUtils.getCurrUserInfo();
        branchDepotInspectService.saveOrUpdateData(model, userPO);
        return ResultView.success(model);
    }

    @ApiOperation(value = "根据id删除", notes = "")
    @DeleteMapping("/authority_button/deleteById/{id}")
    public ResultView deleteById(@PathVariable int id) {
        branchDepotInspectService.deleteById(id);
        return ResultView.success();
    }

}
