package com.unissoft.inspection.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.unissoft.inspection.service.EntrustmentPointInspectService;
import com.unissoft.model.EntrustmentPointInspect;
import com.unissoft.model.SysUserPO;
import com.unissoft.result.PageParam;
import com.unissoft.result.ResultView;
import com.unissoft.utils.UserUtils;
import com.unissoft.vo.EntrustmentPointInspectVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 * 租仓、委托点检查 前端控制器
 * </p>
 *
 * @author root
 * @since 2021-01-27
 */
@Api(description = "租仓、委托点检查")
@RestController
@RequestMapping("/entrustmentPointInspect")
public class EntrustmentPointInspectController {

    @Autowired
    private EntrustmentPointInspectService inspectService;

    @ApiOperation(value = "分页条件查询", notes = "提交参数：{\n" +
            "  \"condition\":\"{'inspecTimeStart':'','inspecTimeEnd':'', 'status':''}\",\n" +
            "  \"pageIndex\": 1,\n" +
            "  \"pageSize\": 10\n" +
            "}")
    @PostMapping("/authority/getAllPage/{depotId}")
    public ResultView getAllPage(@PathVariable("depotId") Integer depotId, @RequestBody PageParam pageParam) {
        Page<EntrustmentPointInspect> page = inspectService.getAllPage(depotId, pageParam);
        return ResultView.success(page);
    }

    @ApiOperation(value = "根据id查询", notes = "")
    @GetMapping("/authority/getDataById/{id}")
    public ResultView getDataById(@PathVariable int id) {
        EntrustmentPointInspectVO result = inspectService.getDataById(id);
        return ResultView.success(result);
    }

    @ApiOperation(value = "新增或修改", notes = "")
    @PostMapping("/authority_button/saveOrUpdateData")
    public ResultView saveOrUpdateData(@RequestBody EntrustmentPointInspectVO model) {
        SysUserPO userPO = UserUtils.getCurrUserInfo();
        inspectService.saveOrUpdateData(model, userPO);
        return ResultView.success(model);
    }


    @ApiOperation(value = "根据id删除", notes = "")
    @DeleteMapping("/authority_button/deleteById/{id}")
    public ResultView deleteById(@PathVariable int id) {
        inspectService.deleteById(id);
        return ResultView.success();
    }

}
