package com.unissoft.inspection.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.unissoft.inspection.service.LocalDepotInspectService;
import com.unissoft.model.LocalDepotInspect;
import com.unissoft.model.SysUserPO;
import com.unissoft.result.PageParam;
import com.unissoft.result.ResultView;
import com.unissoft.utils.UserUtils;
import com.unissoft.vo.LocalDepotInspectVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 * 本库检查 前端控制器
 * </p>
 *
 * @author root
 * @since 2021-01-27
 */
@Api(description = "本库检查")
@RestController
@RequestMapping("/localDepotInspect")
public class LocalDepotInspectController {

    @Autowired
    private LocalDepotInspectService localDepotInspectService;

    @ApiOperation(value = "查询最新数据", notes = "提交参数：")
    @PostMapping("/authority/getEveryTypeNewData/{depotId}")
    public ResultView getEveryTypeNewData(@PathVariable("depotId") Integer depotId) {
        List<LocalDepotInspect> result = localDepotInspectService.getEveryTypeNewData(depotId);
        return ResultView.success(result);
    }

    @ApiOperation(value = "分页条件查询", notes = "提交参数：{\n" +
            "  \"condition\":\"{'inspecTimeStart':'','inspecTimeEnd':'', 'inspecType':'', 'status':''}\",\n" +
            "  \"pageIndex\": 1,\n" +
            "  \"pageSize\": 10\n" +
            "}")
    @PostMapping("/authority/getAllPage/{depotId}")
    public ResultView getAllPage(@PathVariable("depotId") Integer depotId, @RequestBody PageParam pageParam) {
        Page<LocalDepotInspect> page = localDepotInspectService.getAllPage(depotId, pageParam);
        return ResultView.success(page);
    }

    @ApiOperation(value = "根据id查询", notes = "")
    @GetMapping("/authority/getDataById/{id}")
    public ResultView getDataById(@PathVariable int id) {
        LocalDepotInspectVO result = localDepotInspectService.getDataById(id);
        return ResultView.success(result);
    }

    @ApiOperation(value = "新增或修改", notes = "")
    @PostMapping("/authority_button/saveOrUpdateData")
    public ResultView saveOrUpdateData(@RequestBody LocalDepotInspectVO model) {
        SysUserPO userPO = UserUtils.getCurrUserInfo();
        localDepotInspectService.saveOrUpdateData(model, userPO);
        return ResultView.success(model);
    }


    @ApiOperation(value = "根据id删除", notes = "")
    @DeleteMapping("/authority_button/deleteById/{id}")
    public ResultView deleteById(@PathVariable int id) {
        localDepotInspectService.deleteById(id);
        return ResultView.success();
    }

}
