package com.unissoft.inspection.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.unissoft.inspection.service.BranchDepotInspectDetailsService;
import com.unissoft.mapper.BranchDepotInspectDetailsMapper;
import com.unissoft.model.BranchDepotInspectDetails;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 分库检查细节 服务实现类
 * </p>
 *
 * @author root
 * @since 2021-01-27
 */
@Service
public class BranchDepotInspectDetailsServiceImpl extends ServiceImpl<BranchDepotInspectDetailsMapper, BranchDepotInspectDetails> implements BranchDepotInspectDetailsService {

    @Autowired
    private BranchDepotInspectDetailsMapper branchDepotInspectDetailsMapper;

    @Override
    public List<BranchDepotInspectDetails> getByPid(Integer pid) {
        QueryWrapper<BranchDepotInspectDetails> ew = new QueryWrapper<>();
        ew.eq("pid", pid);
        ew.orderByAsc("orderby");
        List<BranchDepotInspectDetails> list = branchDepotInspectDetailsMapper.selectList(ew);
        return list;
    }

    @Override
    public void deleteByPid(Integer pid) {
        QueryWrapper<BranchDepotInspectDetails> ew = new QueryWrapper<>();
        ew.eq("pid", pid);
        branchDepotInspectDetailsMapper.delete(ew);
    }
}
