package com.unissoft.inspection.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.unissoft.inspection.service.EntrustmentPointInspectDetailsService;
import com.unissoft.mapper.EntrustmentPointInspectDetailsMapper;
import com.unissoft.model.EntrustmentPointInspectDetails;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 租仓、委托点检查细节 服务实现类
 * </p>
 *
 * @author root
 * @since 2021-01-27
 */
@Service
public class EntrustmentPointInspectDetailsServiceImpl extends ServiceImpl<EntrustmentPointInspectDetailsMapper, EntrustmentPointInspectDetails> implements EntrustmentPointInspectDetailsService {

    @Autowired
    private EntrustmentPointInspectDetailsMapper entrustmentPointInspectDetailsMapper;

    @Override
    public List<EntrustmentPointInspectDetails> getByPid(Integer pid) {
        QueryWrapper<EntrustmentPointInspectDetails> ew = new QueryWrapper<>();
        ew.eq("pid", pid);
        ew.orderByAsc("orderby");
        List<EntrustmentPointInspectDetails> list = entrustmentPointInspectDetailsMapper.selectList(ew);
        return list;
    }

    @Override
    public void deleteByPid(Integer pid) {
        QueryWrapper<EntrustmentPointInspectDetails> ew = new QueryWrapper<>();
        ew.eq("pid", pid);
        entrustmentPointInspectDetailsMapper.delete(ew);
    }
}
