package com.unissoft.inspection.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.unissoft.inspection.service.LocalDepotInspectDetailsService;
import com.unissoft.mapper.LocalDepotInspectDetailsMapper;
import com.unissoft.model.LocalDepotInspectDetails;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 本库检查细节 服务实现类
 * </p>
 *
 * @author root
 * @since 2021-01-27
 */
@Service
public class LocalDepotInspectDetailsServiceImpl extends ServiceImpl<LocalDepotInspectDetailsMapper, LocalDepotInspectDetails> implements LocalDepotInspectDetailsService {

    @Autowired
    private LocalDepotInspectDetailsMapper localDepotInspectDetailsMapper;

    @Override
    public List<LocalDepotInspectDetails> getByPid(Integer pid) {
        QueryWrapper<LocalDepotInspectDetails> ew = new QueryWrapper<>();
        ew.eq("pid", pid);
        ew.orderByAsc("orderby");
        List<LocalDepotInspectDetails> list = localDepotInspectDetailsMapper.selectList(ew);
        return list;
    }

    @Override
    public void deleteByPid(Integer pid) {
        QueryWrapper<LocalDepotInspectDetails> ew = new QueryWrapper<>();
        ew.eq("pid", pid);
        localDepotInspectDetailsMapper.delete(ew);
    }
}
