package com.unissoft.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.unissoft.model.GrainConditionRecord;
import com.unissoft.model.GrainError;
import com.unissoft.model.GrainErrorEChars;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author root
 * @since 2020-12-04
 */
@Repository
public interface GrainConditionRecordMapper extends BaseMapper<GrainConditionRecord> {

    List<GrainConditionRecord> getByCheckPersonAndCheckTime(@Param("houseId") Integer houseId, @Param("depotId") Integer depotId);

    IPage<GrainError> getGrainErrorCount(IPage<GrainError> iPage, @Param("params") Map<String, Object> map);

    List<GrainErrorEChars> getGrainErrorEChars(@Param("depotIds") List<Integer> depotIds);

    IPage<GrainError> getGrainErrorHouseList(IPage<GrainError> iPage, @Param("params") Map<String, Object> map);

    // List<GrainConditionRecord> getByPersonAndTime();
//    int getSelectRecordId();

//    List<GrainConditionRecord> getAuthGainAbnormal(@Param("depotIds") List<Integer> depotIds);
}
