package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.unissoft.utils.DateUtil;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 分库检查细节
 * </p>
 *
 * @author root
 * @since 2021-01-27
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("branch_depot_inspect_details")
@ApiModel(value="BranchDepotInspectDetails对象", description="分库检查细节")
public class BranchDepotInspectDetails extends BaseModel implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "分库检查表ID")
    @TableField("pid")
    private Integer pid;

    @DateTimeFormat(pattern = DateUtil.PATTERN_DATETIME)
    @JsonFormat(pattern = DateUtil.PATTERN_DATETIME,timezone = "GMT+8")
    @ApiModelProperty(value = "记录时间")
    @TableField("detail_time")
    private Date detailTime;

    @ApiModelProperty(value = "类型")
    @TableField("title")
    private String title;

    @ApiModelProperty(value = "选项，0否，1是")
    @TableField("flag")
    private Boolean flag;

    @ApiModelProperty(value = "排序")
    @TableField("orderby")
    private Integer orderby;

}
