package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.unissoft.utils.DateUtil;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 *
 * </p>
 *
 * @author root
 * @since 2021-01-25
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("equip_facilities")
@ApiModel(value = "EquipFacilities对象", description = "设备检查记录")
public class EquipFacilities implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "设施表主键")
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty(value = "设施种类")
    @TableField("kind")
    private Integer kind;

    @DateTimeFormat(pattern = DateUtil.PATTERN_DATETIME)
    @JsonFormat(pattern = DateUtil.PATTERN_DATETIME,timezone = "GMT+8")
    @ApiModelProperty(value = "检查时间")
    @TableField("check_time")
    private Date checkTime;

    @ApiModelProperty(value = "状态(1:已完成,0:进行中)")
    @TableField("check_state")
    private Integer checkState;

    @ApiModelProperty(value = "检查结果(0:蓝,1:黄)")
    @TableField("check_result")
    private Integer checkResult;

    @ApiModelProperty(value = "所属库id")
    @TableField("depot_id")
    private Integer depotId;

    @ApiModelProperty(value = "所属库名称")
    @TableField("depot_name")
    private String depotName;

    @ApiModelProperty(value = "仓房表id")
    @TableField("h_id")
    private Integer hId;

    @ApiModelProperty(value = "仓房名称")
    @TableField("h_name")
    private String hName;

    @ApiModelProperty(value = "操作人")
    @TableField("operation_person")
    private String operationPerson;

    @ApiModelProperty(value = "数据类型(0:设施,1:库外管理)")
    @TableField("data_type")
    private Integer dataType;


}
