package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.unissoft.utils.DateUtil;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 设备检查记录子表
 * </p>
 *
 * @author root
 * @since 2021-01-25
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("equip_facilities_child")
@ApiModel(value="EquipFacilitiesChild对象", description="设备检查记录子表")
public class EquipFacilitiesChild implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "设置表子表主键id")
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty(value = "关联主表(equip_facilities.id)")
    @TableField("p_id")
    private Integer pId;

    @ApiModelProperty(value = "是否检查(0:否,1:是)")
    @TableField("is_check")
    private Integer isCheck;

    @ApiModelProperty(value = "检查标题编号(字典)")
    @TableField("check_enum_id")
    private Integer checkEnumId;

    @ApiModelProperty(value = "记录时间")
    @DateTimeFormat(pattern = DateUtil.PATTERN_DATETIME)
    @JsonFormat(pattern = DateUtil.PATTERN_DATETIME,timezone = "GMT+8")
    @TableField("operation_time")
    private Date operationTime;


}
