package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 器材库
 * </p>
 *
 * @author My sunShine
 * @since 2021-04-15
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("equipment_stroe")
@ApiModel(value="EquipmentStroe对象", description="器材库")
public class EquipmentStroe implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "器材库id")
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty(value = "库区ID")
    @TableField("depot_id")
    private Integer depotId;

    @ApiModelProperty(value = "设备类别")
    @TableField("equipment_category")
    private String equipmentCategory;

    @ApiModelProperty(value = "设备类别名称")
    @TableField("equipment_category_name")
    private String equipmentCategoryName;

    @ApiModelProperty(value = "设备名称code")
    @TableField("equipment_name_code")
    private String equipmentNameCode;

    @ApiModelProperty(value = "设备名称")
    @TableField("equipment_name")
    private String equipmentName;

    @ApiModelProperty(value = "规格型号")
    @TableField("standards_type")
    private String standardsType;

    @ApiModelProperty(value = "生产厂家")
    @TableField("manufacturer")
    private String manufacturer;

    @ApiModelProperty(value = "资产编号")
    @TableField("asset_number")
    private String assetNumber;

    @ApiModelProperty(value = "设备编号")
    @TableField("equipment_number")
    private String equipmentNumber;

    @ApiModelProperty(value = "到库时间")
    @TableField("arrival_time")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date arrivalTime;

    @ApiModelProperty(value = "管理者")
    @TableField("management")
    private String management;

    @ApiModelProperty(value = "出厂时间")
    @TableField("leave_time")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date leaveTime;

    @ApiModelProperty(value = "企业名称")
    @TableField("enterprise_name")
    private String enterpriseName;

    @ApiModelProperty(value = "登记人")
    @TableField("registrant")
    private String registrant;

    @ApiModelProperty(value = "该设备的状态(0:正常使用1:维修2:报废)")
    @TableField("state")
    private Integer state;


}
