package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 粮情检测记录表
 * </p>
 *
 * @author root
 * @since 2021-02-05
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("grain_condition_record")
@ApiModel(value = "GrainConditionRecord对象", description = "粮情检测记录表")
public class GrainConditionRecord implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "粮情检测记录id")
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty(value = "检查类型")
    @TableField("enum_id")
    private Integer enumId;

    @ApiModelProperty(value = "检查(操作)时间")
    @TableField("operation_time")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date operationTime;

    @ApiModelProperty(value = "记录状态(0进行中，1完成)")
    @TableField("record_status")
    private Integer recordStatus;

    @ApiModelProperty(value = "异常状态(0无异常，1有异常)")
    @TableField("anomalous_status")
    private Integer anomalousStatus;

    @ApiModelProperty(value = "用户id(检查人)")
    @TableField("check_person")
    private Integer checkPerson;

    @ApiModelProperty(value = "仓房id")
    @TableField("house_id")
    private Integer houseId;

    @ApiModelProperty(value = "库id")
    @TableField("depot_id")
    private Integer depotId;

    @ApiModelProperty(value = "检查年份(用于粮情异常等,做年统计)")
    @TableField("check_year")
    private Integer checkYear;

    @ApiModelProperty(value = "检查所在年第几周(一周:周一0:00至周日24:00)")
    @TableField("check_year_week")
    private Integer checkYearWeek;

    @ApiModelProperty(value = "用于同公共枚举同步顺序")
    @TableField("enum_order")
    private Integer enumOrder;

    @ApiModelProperty(value = "虫害异常(字典编码)")
    @TableField("insect_pest_error")
    private Integer insectPestError;

    @ApiModelProperty(value = "水分检测异常")
    @TableField("wet_check_error")
    private Integer wetCheckError;

    @ApiModelProperty(value = "异常粮情")
    @TableField("grain_error")
    private Integer grainError;


}
