package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;

import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

/**
 * <p>
 * 粮情检查记录子表
 * </p>
 *
 * @author root
 * @since 2021-02-05
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("grain_condition_record_child")
@ApiModel(value = "GrainConditionRecordChild对象", description = "粮情检查记录子表")
public class GrainConditionRecordChild implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "粮情检查记录子表")
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty(value = "关联主表id(grain_condition_record.id)")
    @TableField("parent_id")
    private Integer parentId;

    @ApiModelProperty(value = "是否异常_选项(0:否,1:是)")
    @TableField("anomalous_status")
    private Integer anomalousStatus;

    @ApiModelProperty(value = "检查类型(检查项)")
    @TableField("enum_id")
    private Integer enumId;

    @ApiModelProperty(value = "操作时间")
    @TableField("operation_time")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date operationTime;

    /**
     * "errorDescribed": "{'pestDensity':'害虫密度','occurPosition':'发生位置','occurArea':'发生面积','pestType':'害虫类型','abnormalWater':'水分检查异常描述','abnormalGrain':'粮情异常描述'}"
     */
    @ApiModelProperty(value = "粮情情异常描述json字符串")
    @TableField("error_described")
    private String errorDescribed;


}
