package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * @author qingsong.han
 * @description: 粮情异常数据对象
 * @create 2021-02-26 9:43
 */
@Data
@EqualsAndHashCode(callSuper = false)
@ApiModel(value = "粮情异常类", description = "粮情检测记录")
public class GrainError implements Serializable {
    private static final long serialVersionUID = 2162086215502754428L;

    @ApiModelProperty(value = "2021年11周")
    private String yearJoinWeek;
    @ApiModelProperty(value = "库id")
    private Integer depotId;
    @ApiModelProperty(value = "仓房id")
    private Integer houseId;
    @ApiModelProperty(value = "仓房个数")
    private Integer houseCount;
    @ApiModelProperty(value = "异常粮情个数")
    private Integer grainErrorCount;
    @ApiModelProperty(value = "本机构异常粮情 grainError != null && grainError == 191 的为黄色")
    private Integer grainError;
    @ApiModelProperty(value = "检查(操作)时间(子表)")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date operationTime;

}
