package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.unissoft.utils.DateUtil;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 安全巡查
 * </p>
 *
 * @author root
 * @since 2021-01-18
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("grain_security_inspect")
@ApiModel(value="GrainSecurityInspect对象", description="安全巡查")
public class GrainSecurityInspect extends BaseModel implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "类型，1每天安全巡查，2每周安全员例会，3每月安委会例会")
    @TableField("inspec_type")
    private String inspecType;

    @DateTimeFormat(pattern = DateUtil.PATTERN_DATETIME)
    @JsonFormat(pattern = DateUtil.PATTERN_DATETIME,timezone = "GMT+8")
    @ApiModelProperty(value = "最后记录时间")
    @TableField("inspec_time")
    private Date inspecTime;

    @ApiModelProperty(value = "状态，0进行中，1已完成")
    @TableField("status")
    private Integer status;

    @ApiModelProperty(value = "库ID")
    @TableField("depot_id")
    private Integer depotId;

    @ApiModelProperty(value = "库名称")
    @TableField("depot_name")
    private String depotName;

}
