package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 流程审批表
 * </p>
 *
 * @author My sunShine
 * @since 2021-04-15
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("process_audit")
@ApiModel(value="ProcessAudit对象", description="流程审批表")
public class ProcessAudit implements Serializable {

    private static final long serialVersionUID = 1L;

    
    //业务字段
    @TableField(exist = false)
    private String houseName;
    @TableField(exist = false)
	private String applyName;
    @TableField(exist = false)
	private String departmentName;
    @TableField(exist = false)
	private String companyName;
	
	
	
	

    public String getHouseName() {
		return houseName;
	}

	public void setHouseName(String houseName) {
		this.houseName = houseName;
	}

	public String getApplyName() {
		return applyName;
	}

	public void setApplyName(String applyName) {
		this.applyName = applyName;
	}

	public String getDepartmentName() {
		return departmentName;
	}

	public void setDepartmentName(String departmentName) {
		this.departmentName = departmentName;
	}

	public String getCompanyName() {
		return companyName;
	}

	public void setCompanyName(String companyName) {
		this.companyName = companyName;
	}
	
    @ApiModelProperty(value = "流程审批表")
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty(value = "主流程id")
    @TableField("main_id")
    private Integer mainId;

    @ApiModelProperty(value = "子流程的id")
    @TableField("sub_id")
    private Integer subId;

    @ApiModelProperty(value = "子流程的数据(0:是，1:否)")
    @TableField("sub_data")
    private Integer subData;

    @ApiModelProperty(value = "审批状态(0:提交,1审批通过:,2:审批不通过，3:审批完成进行中，4已完成）")
    @TableField("audit_state")
    private Integer auditState;

    @ApiModelProperty(value = "子流程的操作时间")
    @TableField("operation_time")
    private String operationTime;

    @ApiModelProperty(value = "流程类型(如:tf）")
    @TableField("type")
    private String type;

    @ApiModelProperty(value = "仓房id")
    @TableField("house_id")
    private Integer houseId;

    @ApiModelProperty(value = "库id")
    @TableField("depot_id")
    private Integer depotId;

    @ApiModelProperty(value = "提交人")
    @TableField("from_people")
    private Integer fromPeople;

    @ApiModelProperty(value = "审批人")
    @TableField("to_people")
    private Integer toPeople;

    @ApiModelProperty(value = "是否是整个业务的首条记录（1是0否）")
    @TableField("result")
    private Integer result;

    @ApiModelProperty(value = "申请人")
    @TableField("apply_people")
    private Integer applyPeople;

    @ApiModelProperty(value = "审批时间")
    @TableField("audit_time")
    private String auditTime;

    @ApiModelProperty(value = "每一个业务流程的流程标识")
    @TableField("process_id")
    private String processId;

    @ApiModelProperty(value = "进行到哪一步的主流程id")
    @TableField("ongoing_step")
    private String ongoingStep;

    @ApiModelProperty(value = "是否提交给总经理和分公司审批(0否1是)")
    @TableField("is_audit")
    private Integer isAudit;

    @ApiModelProperty(value = "申请时间")
    @TableField("apply_time")
    private String applyTime;

    @ApiModelProperty(value = "流程名称，如 科长每2周粮情检查，通风申请")
    @TableField("work_name")
    private String workName;

    @ApiModelProperty(value = "办理开始时间")
    @TableField("start_date")
    @JsonFormat(shape=JsonFormat.Shape.STRING,pattern="yyyy-MM-dd HH:mm",timezone="GMT+8")
    private Date startDate;

    @ApiModelProperty(value = "办理结束时间")
    @TableField("end_date")
    @JsonFormat(shape=JsonFormat.Shape.STRING,pattern="yyyy-MM-dd HH:mm",timezone="GMT+8")
    private Date endDate;

    @ApiModelProperty(value = "办理页面url")
    @TableField("to_page")
    private String toPage;

    @ApiModelProperty(value = "设备名称code")
    @TableField("equipment_name_code")
    private String equipmentNameCode;

    @ApiModelProperty(value = "器材库的id")
    @TableField("equipment_id")
    private Integer equipmentId;





	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public Integer getMainId() {
		return mainId;
	}

	public void setMainId(Integer mainId) {
		this.mainId = mainId;
	}

	public Integer getSubId() {
		return subId;
	}

	public void setSubId(Integer subId) {
		this.subId = subId;
	}

	public Integer getSubData() {
		return subData;
	}

	public void setSubData(Integer subData) {
		this.subData = subData;
	}

	public Integer getAuditState() {
		return auditState;
	}

	public void setAuditState(Integer auditState) {
		this.auditState = auditState;
	}

	public String getOperationTime() {
		return operationTime;
	}

	public void setOperationTime(String operationTime) {
		this.operationTime = operationTime;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public Integer getHouseId() {
		return houseId;
	}

	public void setHouseId(Integer houseId) {
		this.houseId = houseId;
	}

	public Integer getDepotId() {
		return depotId;
	}

	public void setDepotId(Integer depotId) {
		this.depotId = depotId;
	}

	public Integer getFromPeople() {
		return fromPeople;
	}

	public void setFromPeople(Integer fromPeople) {
		this.fromPeople = fromPeople;
	}

	public Integer getToPeople() {
		return toPeople;
	}

	public void setToPeople(Integer toPeople) {
		this.toPeople = toPeople;
	}

	public Integer getResult() {
		return result;
	}

	public void setResult(Integer result) {
		this.result = result;
	}

	public Integer getApplyPeople() {
		return applyPeople;
	}

	public void setApplyPeople(Integer applyPeople) {
		this.applyPeople = applyPeople;
	}

	public String getAuditTime() {
		return auditTime;
	}

	public void setAuditTime(String auditTime) {
		this.auditTime = auditTime;
	}

	public String getProcessId() {
		return processId;
	}

	public void setProcessId(String processId) {
		this.processId = processId;
	}

	public String getOngoingStep() {
		return ongoingStep;
	}

	public void setOngoingStep(String ongoingStep) {
		this.ongoingStep = ongoingStep;
	}

	public Integer getIsAudit() {
		return isAudit;
	}

	public void setIsAudit(Integer isAudit) {
		this.isAudit = isAudit;
	}

	public String getApplyTime() {
		return applyTime;
	}

	public void setApplyTime(String applyTime) {
		this.applyTime = applyTime;
	}

	public String getWorkName() {
		return workName;
	}

	public void setWorkName(String workName) {
		this.workName = workName;
	}

	public Date getStartDate() {
		return startDate;
	}

	public void setStartDate(Date startDate) {
		this.startDate = startDate;
	}

	public Date getEndDate() {
		return endDate;
	}

	public void setEndDate(Date endDate) {
		this.endDate = endDate;
	}

	public String getToPage() {
		return toPage;
	}

	public void setToPage(String toPage) {
		this.toPage = toPage;
	}

	public String getEquipmentNameCode() {
		return equipmentNameCode;
	}

	public void setEquipmentNameCode(String equipmentNameCode) {
		this.equipmentNameCode = equipmentNameCode;
	}

	public Integer getEquipmentId() {
		return equipmentId;
	}

	public void setEquipmentId(Integer equipmentId) {
		this.equipmentId = equipmentId;
	}


}
