package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * 子流程表
 * </p>
 *
 * @author My SunShine
 * @since 2021-01-30
 */
@TableName("process_sub")
@ApiModel(value="ProcessSub对象", description="子流程表")
public class ProcessSub implements Serializable {

    private static final long serialVersionUID = 1L;

  //业务字段
    @TableField(exist = false)
    private Integer subData;
    @TableField(exist = false)
    private Integer auditId;
    
    
    
    public Integer getAuditId() {
		return auditId;
	}

	public void setAuditId(Integer auditId) {
		this.auditId = auditId;
	}

	public Integer getSubData() {
        return subData;
    }

    public void setSubData(Integer subData) {
        this.subData = subData;
    }
    
    @ApiModelProperty(value = "流程子表")
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty(value = "主流程id")
    @TableField("zid")
    private Integer zid;

    @ApiModelProperty(value = "流程数据选项")
    @TableField("details")
    private String details;

    @ApiModelProperty(value = "流程标题")
    @TableField("title")
    private String title;

    @TableField("operation_time")
    private String operationTime;

    @ApiModelProperty(value = "顺序")
    @TableField("step")
    private Integer step;

    @TableField("type")
    private String type;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }
    public Integer getZid() {
        return zid;
    }

    public void setZid(Integer zid) {
        this.zid = zid;
    }
    public String getDetails() {
        return details;
    }

    public void setDetails(String details) {
        this.details = details;
    }
    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }
    public String getOperationTime() {
        return operationTime;
    }

    public void setOperationTime(String operationTime) {
        this.operationTime = operationTime;
    }
    public Integer getStep() {
        return step;
    }

    public void setStep(Integer step) {
        this.step = step;
    }
    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    @Override
    public String toString() {
        return "ProcessSub{" +
            "id=" + id +
            ", zid=" + zid +
            ", details=" + details +
            ", title=" + title +
            ", operationTime=" + operationTime +
            ", step=" + step +
            ", type=" + type +
        "}";
    }
}
