package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 库存出库质量表
 * </p>
 *
 * @author root
 * @since 2021-01-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("quantity_quality")
@ApiModel(value="QuantityQuality对象", description="库存出库质量表")
public class QuantityQuality implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "q_id", type = IdType.AUTO)
    private Integer qId;

    @ApiModelProperty(value = "检查类别5种类别")
    @TableField("q_type")
    private Integer qType;

    @ApiModelProperty(value = "检测类别名字")
    @TableField("q_type_name")
    private String qTypeName;

    @ApiModelProperty(value = "0库存质量，1出库质量")
    @TableField("depot_ypte")
    private String depotYpte;

    @ApiModelProperty(value = "库点id")
    @TableField("depot_id")
    private Integer depotId;

    @TableField("depot_name")
    private String depotName;

    @ApiModelProperty(value = "仓房id")
    @TableField("warehouse_id")
    private Integer warehouseId;

    @TableField("warehouse_name")
    private String warehouseName;

    @ApiModelProperty(value = "创建时间")
    @JsonFormat(shape=JsonFormat.Shape.STRING,pattern="yyyy-MM-dd HH:mm",timezone="GMT+8")
    @TableField("create_time")
    private Date createTime;

    @ApiModelProperty(value = "质量:0 达标、宜存,1不达标、宜存,2不达标、不宜存")
    @TableField("c_quality")
    private Integer cQuality;

    @ApiModelProperty(value = "品质:0 达标、宜存,1不达标、宜存,2不达标、不宜存")
    @TableField("c_character")
    private Integer cCharacter;

    @ApiModelProperty(value = "毒素指标:0 达标、宜存,1不达标、宜存,2不达标、不宜存")
    @TableField("c_toxin_index")
    private Integer cToxinIndex;

    @ApiModelProperty(value = "0保存，1暂存")
    @TableField("save_state")
    private Integer saveState;

    @ApiModelProperty(value = "备用1")
    @TableField("m_spare")
    private String mSpare;

    @ApiModelProperty(value = "备用2")
    @TableField("m_spare2")
    private String mSpare2;
}
