package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 工作完成情况统计表
 * </p>
 *
 * @author root
 * @since 2021-02-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("statistics_work_completion")
@ApiModel(value="StatisticsWorkCompletion对象", description="工作完成情况统计表")
public class StatisticsWorkCompletion implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty(value = "人员id")
    @TableField("personnel_id")
    private Integer personnelId;

    @ApiModelProperty(value = "人员名称")
    @TableField("personnel_name")
    private String personnelName;

    @ApiModelProperty(value = "职位")
    @TableField("s_position")
    private String sPosition;

    @ApiModelProperty(value = "库id（公司id）")
    @TableField("depot_id")
    private Integer depotId;

    @ApiModelProperty(value = "库名称（公司名称）")
    @TableField("depot_name")
    private String depotName;

    @ApiModelProperty(value = "所在市区")
    @TableField("urban_area")
    private String urbanArea;

    @ApiModelProperty(value = "月工作数量")
    @TableField("monthly_work_quantity")
    private Integer monthlyWorkQuantity;

    @ApiModelProperty(value = "按时完成")
    @TableField("finish_on_time")
    private Integer finishOnTime;

    @ApiModelProperty(value = "逾期完成")
    @TableField("late_completion")
    private Integer lateCompletion;

    @ApiModelProperty(value = "逾期未完成")
    @TableField("s_overdue")
    private Integer sOverdue;

    @ApiModelProperty(value = "得分")
    @TableField("s_score")
    private Integer sScore;

    @ApiModelProperty(value = "统计时间")
    @JsonFormat(shape=JsonFormat.Shape.STRING,pattern="yyyy-MM-dd HH:mm",timezone="GMT+8")
    @TableField("s_time")
    private Date sTime;

    @ApiModelProperty(value = "备用字段")
    @TableField("s_spare")
    private String sSpare;

    @ApiModelProperty(value = "备用2")
    @TableField("s_spare2")
    private String sSpare2;

    @ApiModelProperty(value = "备用3")
    @TableField("s_spare3")
    private String sSpare3;

    public StatisticsWorkCompletion() {
    }

    public StatisticsWorkCompletion(Integer personnelId, String personnelName, String sPosition, Integer depotId, String depotName, Integer monthlyWorkQuantity, Integer finishOnTime, Integer lateCompletion, Integer sOverdue, Integer sScore, Date sTime) {
        this.personnelId = personnelId;
        this.personnelName = personnelName;
        this.sPosition = sPosition;
        this.depotId = depotId;
        this.depotName = depotName;
        this.monthlyWorkQuantity = monthlyWorkQuantity;
        this.finishOnTime = finishOnTime;
        this.lateCompletion = lateCompletion;
        this.sOverdue = sOverdue;
        this.sScore = sScore;
        this.sTime = sTime;
    }
}
