package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 用户活跃度统计表
 * </p>
 *
 * @author root
 * @since 2021-03-10
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("sys_user_activity")
@ApiModel(value = "SysUserActivity对象", description = "用户活跃度统计表")
public class SysUserActivity implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty(value = "用户表id")
    @TableField("user_id")
    private Integer userId;

    @ApiModelProperty(value = "人员表姓名")
    @TableField("personnel_name")
    private String personnelName;

    @ApiModelProperty(value = "库id")
    @TableField("depot_id")
    private Integer depotId;

    @ApiModelProperty(value = "库名称")
    @TableField("depot_name")
    private String depotName;

    @ApiModelProperty(value = "省排名")
    @TableField("province_ranking")
    private Integer provinceRanking;

    @ApiModelProperty(value = "库排名")
    @TableField("depot_ranking")
    private Integer depotRanking;

    @ApiModelProperty(value = "人员职位")
    @TableField("s_position")
    private String sPosition;

    @ApiModelProperty(value = "待办统计id")
    @TableField("completion_id")
    private Integer completionId;

    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @TableField("act_time")
    private Date actTime;

    @ApiModelProperty(value = "用户活跃度得分")
    @TableField("us_activity")
    private Integer usActivity;

    @ApiModelProperty(value = "备用1")
    @TableField("spare_one")
    private String spareOne;

    @ApiModelProperty(value = "备用2")
    @TableField("spare_two")
    private String spareTwo;

    public SysUserActivity() {
    }

    public SysUserActivity(Integer userId, String personnelName, Integer depotId, String depotName, String sPosition, Date actTime, Integer usActivity) {
        this.userId = userId;
        this.personnelName = personnelName;
        this.depotId = depotId;
        this.depotName = depotName;
        this.sPosition = sPosition;
        this.actTime = actTime;
        this.usActivity = usActivity;
    }
}
