package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 入库质量表名称
 * </p>
 *
 * @author root
 * @since 2021-04-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("warehousing_quality")
@ApiModel(value="WarehousingQuality对象", description="入库质量表名称")
public class WarehousingQuality implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty(value = "库点id")
    @TableField("depot_id")
    private Integer depotId;

    @ApiModelProperty(value = "库点名称")
    @TableField("depot_name")
    private String depotName;

    @ApiModelProperty(value = "仓房id")
    @TableField("warehouse_id")
    private Integer warehouseId;

    @ApiModelProperty(value = "仓房名称")
    @TableField("warehouse_name")
    private String warehouseName;

    @ApiModelProperty(value = "检测名称当前处于类型")
    @TableField("check_name")
    private String checkName;

    @ApiModelProperty(value = "检测类型（0：1/3,1:1/2,2:2/3,3:自验收,4:质检中心验收,5:质检中心巡检）")
    @TableField("check_type")
    private Integer checkType;

    @ApiModelProperty(value = "创建时间")
    @TableField("creation_time")
    private Date creationTime;

    @ApiModelProperty(value = "结束时间")
    @TableField("end_time")
    private Date endTime;

    @ApiModelProperty(value = "0进行中，1完成")
    @TableField("quality_state")
    private Integer qualityState;

    public WarehousingQuality() {
    }

    public WarehousingQuality(Integer depotId, String depotName, Integer warehouseId, String warehouseName, String checkName, Integer checkType, Date creationTime, Date endTime, Integer qualityState) {
        this.depotId = depotId;
        this.depotName = depotName;
        this.warehouseId = warehouseId;
        this.warehouseName = warehouseName;
        this.checkName = checkName;
        this.checkType = checkType;
        this.creationTime = creationTime;
        this.endTime = endTime;
        this.qualityState = qualityState;
    }
}
