package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 入库质量表名称字表
 * </p>
 *
 * @author root
 * @since 2021-04-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("warehousing_quality_children")
@ApiModel(value="WarehousingQualityChildren对象", description="入库质量表名称字表")
public class WarehousingQualityChildren implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer childrenId;

    @ApiModelProperty(value = "入库质量表id")
    @TableField("warehousing_id")
    private Integer warehousingId;

    @ApiModelProperty(value = "内置序列号")
    @TableField("w_index")
    private Integer wIndex;

    @ApiModelProperty(value = "记录时间")
    @JsonFormat(shape=JsonFormat.Shape.STRING,pattern="yyyy-MM-dd HH:mm",timezone="GMT+8")
    @TableField("creation_time")
    private Date creationTime;

    @ApiModelProperty(value = "检测类型名称")
    @TableField("check_name")
    private String checkName;

    @ApiModelProperty(value = "检测类型（0：1/3,1:1/2,2:2/3,3:自验收,4:质检中心验收,5:质检中心巡检）")
    @TableField("check_type")
    private Integer checkType;

    @ApiModelProperty(value = "质量（0达标宜存，1不达标宜存，2不达标不宜存）")
    @TableField("w_quality")
    private Integer wQuality;

    @ApiModelProperty(value = "品质（0达标宜存，1不达标宜存，2不达标不宜存）")
    @TableField("w_character")
    private Integer wCharacter;

    @ApiModelProperty(value = "毒素指标（0达标宜存，1不达标宜存，2不达标不宜存）")
    @TableField("toxin_index")
    private Integer toxinIndex;

    @ApiModelProperty(value = "备用字段")
    @TableField("spare_field")
    private String spareField;

    public WarehousingQualityChildren() {
    }

    public WarehousingQualityChildren(Integer warehousingId, Integer wIndex, Date creationTime, String checkName, Integer checkType, Integer wQuality, Integer wCharacter, Integer toxinIndex) {
        this.warehousingId = warehousingId;
        this.wIndex = wIndex;
        this.creationTime = creationTime;
        this.checkName = checkName;
        this.checkType = checkType;
        this.wQuality = wQuality;
        this.wCharacter = wCharacter;
        this.toxinIndex = toxinIndex;
    }
}
