package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 入库质量表名称
 * </p>
 *
 * @author root
 * @since 2021-04-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="WarehousingQualityPO", description="入库质量表名称包装实体")
public class WarehousingQualityPO implements Serializable {

    private static final long serialVersionUID = 1L;

    private Integer id;

    @ApiModelProperty(value = "库点id")
    private Integer depotId;

    @ApiModelProperty(value = "库点名称")
    private String depotName;

    @ApiModelProperty(value = "仓房id")
    private Integer warehouseId;

    @ApiModelProperty(value = "仓房名称")
    private String warehouseName;

    @ApiModelProperty(value = "检测名称当前处于类型")
    private String checkName;

    @ApiModelProperty(value = "检测类型（0：1/3,1:1/2,2:2/3,3:自验收,4:质检中心验收,5:质检中心巡检）")
    private Integer checkType;

    @ApiModelProperty(value = "创建时间")
    @JsonFormat(shape=JsonFormat.Shape.STRING,pattern="yyyy-MM-dd HH:mm",timezone="GMT+8")
    private Date creationTime;

    @ApiModelProperty(value = "结束时间")
    @JsonFormat(shape=JsonFormat.Shape.STRING,pattern="yyyy-MM-dd HH:mm",timezone="GMT+8")
    private Date endTime;

    @ApiModelProperty(value = "0进行中，1完成")
    private Integer qualityState;

    private List<WarehousingQualityChildren> qualityChildrens;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getDepotId() {
        return depotId;
    }

    public void setDepotId(Integer depotId) {
        this.depotId = depotId;
    }

    public String getDepotName() {
        return depotName;
    }

    public void setDepotName(String depotName) {
        this.depotName = depotName;
    }

    public Integer getWarehouseId() {
        return warehouseId;
    }

    public void setWarehouseId(Integer warehouseId) {
        this.warehouseId = warehouseId;
    }

    public String getWarehouseName() {
        return warehouseName;
    }

    public void setWarehouseName(String warehouseName) {
        this.warehouseName = warehouseName;
    }

    public String getCheckName() {
        return checkName;
    }

    public void setCheckName(String checkName) {
        this.checkName = checkName;
    }

    public Integer getCheckType() {
        return checkType;
    }

    public void setCheckType(Integer checkType) {
        this.checkType = checkType;
    }

    public Date getCreationTime() {
        return creationTime;
    }

    public void setCreationTime(Date creationTime) {
        this.creationTime = creationTime;
    }

    public Date getEndTime() {
        return endTime;
    }

    public void setEndTime(Date endTime) {
        this.endTime = endTime;
    }

    public Integer getQualityState() {
        return qualityState;
    }

    public void setQualityState(Integer qualityState) {
        this.qualityState = qualityState;
    }

    public List<WarehousingQualityChildren> getQualityChildrens() {
        return qualityChildrens;
    }

    public void setQualityChildrens(List<WarehousingQualityChildren> qualityChildrens) {
        this.qualityChildrens = qualityChildrens;
    }
}
