package com.unissoft.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 入库质量表名称
 * </p>
 *
 * @author root
 * @since 2021-04-12
 */
@Data
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="WarehousingQualityVO", description="入库质量表名称包装实体")
public class WarehousingQualityVO implements Serializable {

    private static final long serialVersionUID = 1L;

    private Integer id;

    private Integer childrenId;

    @ApiModelProperty(value = "标识是否第一次新增，0代表第一次，1代表n次")
    private Integer saveType;

    @ApiModelProperty(value = "库点id")
    private Integer depotId;

    @ApiModelProperty(value = "库点名称")
    private String depotName;

    @ApiModelProperty(value = "仓房id")
    private Integer warehouseId;

    @ApiModelProperty(value = "仓房名称")
    private String warehouseName;

    @ApiModelProperty(value = "检测名称当前处于类型")
    private String checkName;

    @ApiModelProperty(value = "检测类型（0：1/3,1:1/2,2:2/3,3:自验收,4:质检中心验收,5:质检中心巡检）")
    private Integer checkType;

    @ApiModelProperty(value = "创建时间")
    private Date creationTime;

    @ApiModelProperty(value = "结束时间")
    private Date endTime;

    @ApiModelProperty(value = "0进行中，1完成")
    private Integer qualityState;

    @ApiModelProperty(value = "入库质量表id")
    private Integer warehousingId;

    @ApiModelProperty(value = "内置序列号")
    private Integer wIndex;

    @ApiModelProperty(value = "质量（0达标宜存，1不达标宜存，2不达标不宜存）")
    private Integer wQuality;

    @ApiModelProperty(value = "品质（0达标宜存，1不达标宜存，2不达标不宜存）")
    private Integer wCharacter;

    @ApiModelProperty(value = "毒素指标（0达标宜存，1不达标宜存，2不达标不宜存）")
    private Integer toxinIndex;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getDepotId() {
        return depotId;
    }

    public void setDepotId(Integer depotId) {
        this.depotId = depotId;
    }

    public String getDepotName() {
        return depotName;
    }

    public void setDepotName(String depotName) {
        this.depotName = depotName;
    }

    public Integer getWarehouseId() {
        return warehouseId;
    }

    public void setWarehouseId(Integer warehouseId) {
        this.warehouseId = warehouseId;
    }

    public String getWarehouseName() {
        return warehouseName;
    }

    public void setWarehouseName(String warehouseName) {
        this.warehouseName = warehouseName;
    }

    public String getCheckName() {
        return checkName;
    }

    public void setCheckName(String checkName) {
        this.checkName = checkName;
    }

    public Integer getCheckType() {
        return checkType;
    }

    public void setCheckType(Integer checkType) {
        this.checkType = checkType;
    }

    public Date getCreationTime() {
        return creationTime;
    }

    public void setCreationTime(Date creationTime) {
        this.creationTime = creationTime;
    }

    public Date getEndTime() {
        return endTime;
    }

    public void setEndTime(Date endTime) {
        this.endTime = endTime;
    }

    public Integer getQualityState() {
        return qualityState;
    }

    public void setQualityState(Integer qualityState) {
        this.qualityState = qualityState;
    }

    public Integer getWarehousingId() {
        return warehousingId;
    }

    public void setWarehousingId(Integer warehousingId) {
        this.warehousingId = warehousingId;
    }

    public Integer getwIndex() {
        return wIndex;
    }

    public void setwIndex(Integer wIndex) {
        this.wIndex = wIndex;
    }

    public Integer getwQuality() {
        return wQuality;
    }

    public void setwQuality(Integer wQuality) {
        this.wQuality = wQuality;
    }

    public Integer getwCharacter() {
        return wCharacter;
    }

    public void setwCharacter(Integer wCharacter) {
        this.wCharacter = wCharacter;
    }

    public Integer getToxinIndex() {
        return toxinIndex;
    }

    public void setToxinIndex(Integer toxinIndex) {
        this.toxinIndex = toxinIndex;
    }

    public Integer getChildrenId() {
        return childrenId;
    }

    public void setChildrenId(Integer childrenId) {
        this.childrenId = childrenId;
    }
}
