package com.unissoft.policySystem.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.unissoft.model.PolicySystem;
import com.unissoft.policySystem.service.PolicySystemService;
import com.unissoft.result.PageParam;
import com.unissoft.result.ResultView;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author root
 * @since 2020-12-15
 */
@Api(description = "系统管理政策制度")
@RestController
@RequestMapping("/policySystem")
public class PolicySystemController {

    @Autowired
    private PolicySystemService policySystemService ;


    @ApiOperation(value = "分页条件查询", notes = "提交参数：{\"pageIndex\":\"0\", \"pageSize\":\"h\", \"condition\":\"{\\\"asset_number\\\":\\\"\\\",\\\"equipment_category\\\":\\\"\\\",\\\"equipment_name\\\":\\\"\\\",\\\"standards_type\\\":\\\"\\\",\\\"arrival_time\\\":\\\"\\\"}\"}")
    @PostMapping("/authority/getPage")
    public ResultView getPage(@RequestBody PageParam pageParam) {
        Page<PolicySystem> page = policySystemService.getPage(pageParam);
        return ResultView.success(page);
    }

    @ApiOperation(value = "新增", notes = "")
    @PostMapping("/authority_button/add")
    public ResultView add(@RequestBody PolicySystem model) {
        policySystemService.savePolicySystem(model);
        return ResultView.success(model);
    }

    @ApiOperation(value = "上传附件", notes = "")
    @PostMapping("/authority_button/upload")
    public ResultView add(@RequestParam(name = "file") MultipartFile file, @RequestParam(name = "id") Integer id) throws Exception {
        String attachmentPath = policySystemService.savePolicySystemAttachment(file, id);
        return ResultView.success(attachmentPath);
    }


    @ApiOperation(value = "修改", notes = "")
    @PostMapping("/authority_button/update")
    public ResultView update(@RequestBody PolicySystem model) {
        policySystemService.updateById(model);
        return ResultView.success(model);
    }

    @ApiOperation(value = "根据id删除", notes = "")
    @DeleteMapping("/authority_button/deleteById/{id}")
    public ResultView deleteById(@PathVariable Integer id) {
        policySystemService.deleteById(id);
        return ResultView.success();
    }
}
