package com.unissoft.quantityQuality.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.unissoft.model.WarehousingQualityPO;
import com.unissoft.model.WarehousingQualityVO;
import com.unissoft.quantityQuality.service.WarehousingQualityService;
import com.unissoft.result.PageParam;
import com.unissoft.result.ResultView;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 * 入库质量表名称 前端控制器
 * </p>
 *
 * @author root
 * @since 2021-04-12
 */
@Api(description = "入库质量控制类")
@RestController
@RequestMapping("/warehousingQuality")
public class WarehousingQualityController {

    @Autowired
    private WarehousingQualityService qualityService;

    @ApiOperation(value = "分页条件查询", notes = "提交参数：{\"pageIndex\":1,\"pageSize\":10,\"condition\":\"{'depotId':'','warehouseId':'','creationTimeStart':'','creationTimeEnd':''}\"}")
    @PostMapping("/authority/getPage")
    public ResultView getPage(@RequestBody PageParam pageParam) {
        IPage<WarehousingQualityPO> page = qualityService.getPage(pageParam);
        return ResultView.success(page);
    }

    @ApiOperation(value = "根据id查询", notes = "")
    @GetMapping("/authority/getById")
    public ResultView getById(@RequestParam int id) {
        WarehousingQualityPO byIdQality = qualityService.getByIdQality(id);
        return ResultView.success(byIdQality);
    }

    @ApiOperation(value = "新增", notes = "")
    @PostMapping("/authority_button/add")
    public ResultView add(@RequestBody WarehousingQualityVO model) {
        qualityService.saveWarehousingQuality(model);
        return ResultView.success(model);
    }

    @ApiOperation(value = "修改", notes = "")
    @PostMapping("/authority_button/update")
    public ResultView update(@RequestBody WarehousingQualityVO model) {
        qualityService.updateWarehousingQuality(model);
        return ResultView.success(model);
    }

    @ApiOperation(value = "根据id删除", notes = "")
    @DeleteMapping("/authority_button/deleteById")
    public ResultView deleteById(@RequestParam int id) {
        qualityService.deleteById(id);
        return ResultView.success();
    }
}
