package com.unissoft.quantityQuality.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.unissoft.mapper.WarehousingQualityChildrenMapper;
import com.unissoft.model.WarehousingQualityChildren;
import com.unissoft.model.WarehousingQualityVO;
import com.unissoft.quantityQuality.service.WarehousingQualityChildrenService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 入库质量表名称字表 服务实现类
 * </p>
 *
 * @author root
 * @since 2021-04-12
 */
@Service
public class WarehousingQualityChildrenServiceImpl extends ServiceImpl<WarehousingQualityChildrenMapper, WarehousingQualityChildren> implements WarehousingQualityChildrenService {

    @Autowired
    private WarehousingQualityChildrenMapper qualityChildrenMapper;

    @Override
    public void deleteByQualityId(int id) {
        QueryWrapper<WarehousingQualityChildren> qw = new QueryWrapper<>();
        qw.eq("warehousing_id", id);
        qualityChildrenMapper.delete(qw);
    }

    @Override
    public void saveWarehousingQualityChildren(WarehousingQualityVO model) {
        WarehousingQualityChildren qualityChildren = new WarehousingQualityChildren(model.getId(), model.getwIndex(), model.getCreationTime(), model.getCheckName(), model.getCheckType(), model.getwQuality(), model.getwCharacter(), model.getToxinIndex());
        qualityChildrenMapper.insert(qualityChildren);
    }

    @Override
    public void updateWarehousingQualityChildren(WarehousingQualityVO model) {
        WarehousingQualityChildren qualityChildren = new WarehousingQualityChildren(model.getId(), model.getwIndex(), model.getCreationTime(), model.getCheckName(), model.getCheckType(), model.getwQuality(), model.getwCharacter(), model.getToxinIndex());
        qualityChildren.setChildrenId(model.getChildrenId());
        qualityChildrenMapper.updateById(qualityChildren);
    }
}
