package com.unissoft.test;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jasypt.encryption.StringEncryptor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

@Api(description = "加密工具")
@RestController
public class EncryptorController {

    @Autowired
    private StringEncryptor encryptor;

    @ApiOperation(value = "查询加密后字符串", notes = "提交参数：code")
    @GetMapping("/getEncCode/{code}")
    public String getEncCode(@PathVariable("code") String code) {
        String encCode = encryptor.encrypt(code);
//        System.out.println(encCode);
//        System.out.println(encryptor.decrypt(encCode));
        return encCode;
    }

}
