package com.unissoft.ventilation.controller;


import com.unissoft.model.ProcessBasis;
import com.unissoft.result.ResultView;
import com.unissoft.ventilation.service.ProcessBasisService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author My SunShine
 * @since 2020-12-07
 */
@Api(description = "审批人控制器")
@RestController
@RequestMapping("/ventilation/processBasis")
public class ProcessBasisController {

	
	@Autowired
    private ProcessBasisService processBasisService;
	
	@ApiOperation(value = "新增审批人管理", notes = "")
    @PostMapping("/add")
    public ResultView add(@RequestBody String parameter) {
		processBasisService.add(parameter);
        return ResultView.success();
    }

	
	/**
	 * 根据类型获取审批人信息(回显，初始化页面的时候用)
	 * @param parameter
	 * @return
	 */
	@ApiOperation(value = "根据类型获取审批人信息", notes = "")
	@GetMapping("/getBasisByType/{type}/{userId}/{depotId}")
    public ResultView getAllProcess(@PathVariable String type,@PathVariable Integer userId,@PathVariable Integer depotId) {
		List<ProcessBasis> list = processBasisService.getBasisByType(type,userId,depotId);
        return ResultView.success(list);
    }
	
	
}
