package com.unissoft.ventilation.controller;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import com.unissoft.model.ProcessSub;
import com.unissoft.result.ResultView;
import com.unissoft.ventilation.service.ProcessMainService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author My SunShine
 * @since 2020-12-08
 */
@Api(description = "主流程控制器")
@RestController
@RequestMapping("/ventilation/processMain")
public class ProcessMainController {

	@Autowired
    private ProcessMainService processMainService;
	
	
	/**
	 * 获取所有主流程和子流程的数据   (新增时)
	 * @param parameter
	 * @return
	 */
	@ApiOperation(value = "获取所有主流程和子流程的数据", notes = "")
	@GetMapping("/getAllProcess/{type}")
    public ResultView getAllProcess(@PathVariable String type) {
		List<Map<String,Object>> list = processMainService.getAllProcess(type);
        return ResultView.success(list);
    }
	
	
	public static void main(String[] args) {
		List<ProcessSub> list = new ArrayList<ProcessSub>();
		ProcessSub ProcessSub = new ProcessSub();
		ProcessSub.setAuditId(1111);
		ProcessSub.setTitle("测试1");
		ProcessSub ProcessSub1 = new ProcessSub();
		ProcessSub1.setAuditId(2222);
		ProcessSub1.setTitle("测试2");
		list.add(ProcessSub1);
		list.add(ProcessSub);
		list.forEach(obj -> System.out.println(obj.getTitle()));
		
		
		/*List<String> books = new ArrayList<String>(3);
        books.add("TEST1");
        books.add("TEST2");
        books.forEach(obj -> System.out.println(obj));*/
        
        Map maps = new HashMap();
        maps.put(1, "test1");
        maps.put(2, "test2");
       // maps.forEach((k, v) -> System.out.println("Key : " + k + " Value : " + v));
        maps.forEach((k,v)-> System.out.println("key:"+k+"value:"+v));

	}
	
}
