package com.unissoft.ventilation.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.unissoft.model.SysUserActivity;
import com.unissoft.result.PageParam;
import com.unissoft.result.ResultView;
import com.unissoft.ventilation.service.SysUserActivityService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * <p>
 * 用户活跃度统计表 前端控制器
 * </p>
 *
 * @author root
 * @since 2021-03-10
 */
@Api(description = "用户活跃度统计")
@RestController
@RequestMapping("/sysUserActivity")
public class SysUserActivityController {

    @Autowired
    private SysUserActivityService activityService;

    @ApiOperation(value = "统计列表分页查询,其中type属性代表是否查询单个库下面的数据（1代表单个库，空代表所有）；groupBy=1代表查询首页跳转到分页列表，groupBy=2代表查看库内活跃排名分页列表", notes = "{\n" +
            "  \"condition\": \"{'depotId':'2','sTime':'2021-03','type':'1'}\",\n" +
            "  \"pageIndex\": 1,\n" +
            "  \"pageSize\": 10\n" +
            "}")
    @PostMapping("/getByPage")
    public ResultView getByPage(@RequestBody PageParam pageParam) {
        IPage<SysUserActivity> byPage = activityService.getByPage(pageParam);
        return ResultView.success(byPage);
    }

    @ApiOperation(value = "首页右侧工作统计查询", notes = "depotId库编码，homeType<1.分公司领导首页 2.库主任及以上领导首页 3.员工首页>")
    @GetMapping("/getGroupByDepotId")
    public ResultView getGroupByDepotId(@RequestParam("depotId") Integer depotId, @RequestParam("homeType") Integer homeType) {
        Map<String, Object> groupByDepotId = activityService.getGroupByDepotId(depotId, homeType);
        return ResultView.success(groupByDepotId);
    }
}
