package com.unissoft.ventilation.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.unissoft.dto.ProcessToBeDone;
import com.unissoft.dto.SendNoticeVO;
import com.unissoft.dto.ToBeDoneCallbackVO;
import com.unissoft.model.ProcessAudit;
import com.unissoft.result.PageParam;
import org.json.JSONException;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author My SunShine
 * @since 2020-12-08
 */
public interface ProcessAuditService extends IService<ProcessAudit> {

	void add(String parameter)throws JSONException;

	Page<ProcessAudit> getPage(PageParam pageParam)throws Exception;

	//List<Map<String, Object>> getAllById(Integer id);

	void deleteById(Integer id);

	Page<ProcessAudit> toDisposeList(PageParam pageParam)throws Exception;

	void audit(String parameter);

	void detailsAdd (String parameter)throws JSONException;

	Map<String, Object> getDataByProcessId(String processId);

	Page<ProcessAudit> applyList(PageParam pageParam) throws JSONException;

	Page<ProcessAudit> completeList(PageParam pageParam) throws JSONException;

	List<ToBeDoneCallbackVO> toBeDone(ProcessToBeDone processToBeDone);

	void haveDone(Integer id,Integer auditState);

	void haveDone(Integer userId, String type, Integer depotId, Integer houseId,Integer auditState);

	void haveDone(Integer userId, String type, Integer depotId, Integer auditState);

	List<Integer> getNotBeDoneNotice(String toBeDoneIds);

	void yjcgAudit(String parameter);

	void drugDetailsAdd(String parameter)throws JSONException;

	/**
	 * 获取当月数据
	 * @return 返回当前月数据
	 */
	List<ProcessAudit> getCurrentMonthData();
}
