package com.unissoft.ventilation.service.impl;


import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.google.common.collect.Maps;
import com.unissoft.MyConstant;
import com.unissoft.dto.ProcessToBeDone;
import com.unissoft.dto.SendNoticeVO;
import com.unissoft.dto.SysNoticeVO;
import com.unissoft.dto.ToBeDoneCallbackVO;
import com.unissoft.equipmentStroe.service.EquipmentStroeService;
import com.unissoft.feign.MessageFeign;
import com.unissoft.feign.SystemFeign;
import com.unissoft.mapper.*;
import com.unissoft.model.*;
import com.unissoft.result.PageParam;
import com.unissoft.result.ResultView;
import com.unissoft.ventilation.service.ProcessAuditService;
import com.unissoft.ventilation.service.ProcessBasisService;
import com.unissoft.vo.ProcessToBeDoneVO;
import org.apache.commons.lang.StringUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.text.SimpleDateFormat;
import java.util.*;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author My SunShine
 * @since 2020-12-08
 */
@Service
public class ProcessAuditServiceImpl extends ServiceImpl<ProcessAuditMapper, ProcessAudit> implements ProcessAuditService {

    @Autowired
    private ProcessAuditMapper processAuditMapper;

    @Autowired
    private ProcessMainMapper processMainMapper;

    @Autowired
    private ProcessSubMapper processSubMapper;

    @Autowired
    private ProcessBasisMapper processBasisMapper;

    @Autowired
    private ProcessBasisSonMapper processBasisSonMapper;

    @Autowired
    private ProcessBasisService processBasisService;

    @Autowired
    private SystemFeign systemFeign;

    @Autowired
    private MessageFeign messageFeign;

    @Autowired
    private RestTemplate restTemplate;
    
    @Autowired
    private EquipmentStroeService quipmentStroeServicee;


    @Override
    public void add(String parameter) throws JSONException {

    	org.json.JSONObject jsStr = new org.json.JSONObject(parameter);
        //JSONObject jsStr = JSONObject.parseObject(parameter);
        String type = jsStr.optString("type");//流程类型
        Integer houseId = jsStr.optInt("houseId");//仓房id
        Integer depotId = jsStr.optInt("depotId");//库id
        Integer applyPeople = jsStr.optInt("applyPeople");//申请人id
        Integer fromPeople = jsStr.optInt("fromPeople");//提交人id
        String applyTime = jsStr.optString("applyTime");//申请时间
        Integer isAudit = jsStr.optInt("isAudit");//是否提交给总经理和分公司审批
        String equipmentNameCode = jsStr.optString("equipmentNameCode");//设备名称code
        Integer equipmentId = jsStr.optInt("equipmentId");//器材库的id
        //获取审批人
        List<ProcessBasis> pbList = processBasisService.getBasisByType(type, null, depotId);
        Integer toPeople = pbList.get(1).getContent();

        String ongoingStep = jsStr.optString("ongoingStep");//进行到哪一步的主流程id
    	org.json.JSONArray jsonArray = jsStr.optJSONArray("subList");//子流程数据
        JSONObject row = null; 
        String uuId = UUID.randomUUID().toString();//唯一的流程标识
        for (int i = 0; i < jsonArray.length(); i++) {
            row = jsonArray.getJSONObject(i);
            Integer mainId = row.optInt("mainId");//主流程id
            Integer subId = row.optInt("subId");//子流程id
            Integer subData = row.optInt("subData");//子流程数据
            String operationTime = row.optString("operationTime");//子流程的操作时间
            String processId = row.optString("processId");//流程标识
            
            ProcessAudit processAudit = new ProcessAudit();
            if(mainId != 0){
            	processAudit.setMainId(mainId);
            }
            if(subId != 0){
            	processAudit.setSubId(subId);
            }
            if(operationTime != null){
            	processAudit.setOperationTime(operationTime);
            }
            
            processAudit.setSubData(subData);
            processAudit.setType(type);
            processAudit.setOngoingStep(ongoingStep);
            processAudit.setIsAudit(isAudit);
            if (type.equals("tf")) {
                processAudit.setWorkName(EnumProcessModel.tf.getName());
            }else if(type.equals("yjcg")){
            	processAudit.setWorkName(EnumProcessModel.yjcg.getName());
            }else if(type.equals("yjly")){
            	processAudit.setWorkName(EnumProcessModel.yjly.getName());
            }else if(type.equals("xzjh")){
            	processAudit.setWorkName(EnumProcessModel.xzjh.getName());
            }else if(type.equals("xzsq")){
            	processAudit.setWorkName(EnumProcessModel.xzsq.getName());
            }else if(type.equals("sswxjh")){
            	processAudit.setWorkName(EnumProcessModel.sswxjh.getName());
            }else if(type.equals("sswxys")){
            	processAudit.setWorkName(EnumProcessModel.sswxys.getName());
            }else if(type.equals("sbcg")){
            	processAudit.setWorkName(EnumProcessModel.sbcg.getName());
            }else if(type.equals("sbwx")){
            	processAudit.setWorkName(EnumProcessModel.sbwx.getName());
            }else if(type.equals("sbly")){
            	processAudit.setWorkName(EnumProcessModel.sbly.getName());
            }else if(type.equals("sbgh")){
            	processAudit.setWorkName(EnumProcessModel.sbgh.getName());
            }else if(type.equals("sbbf")){
            	processAudit.setWorkName(EnumProcessModel.sbbf.getName());
            }
            

            if(i == 0 ){
            	processAudit.setFromPeople(fromPeople);
                processAudit.setToPeople(toPeople);
                if(houseId != 0 && houseId != null){
                	processAudit.setHouseId(houseId);
                }
                if(equipmentNameCode !=null && equipmentNameCode != ""){
                	processAudit.setEquipmentNameCode(equipmentNameCode);
                }
                if(equipmentId != 0 && equipmentId != null){
                	processAudit.setEquipmentId(equipmentId);
                }
                processAudit.setDepotId(depotId);
                processAudit.setApplyPeople(applyPeople);
                processAudit.setApplyTime(applyTime);
                processAudit.setAuditState(0);//已提交
            	if(ongoingStep.equals(0+"")){//第一个带审批
	                processAudit.setResult(1);//第一条数据 保存并审批  1是0否
	                processAudit.setProcessId(uuId);//唯一的流程标识
                }else{ //其他步骤带审批的
            		//修改第一条数据
            		QueryWrapper<ProcessAudit> ew = new QueryWrapper<>();
            		ew.eq("process_id", processId).eq("result", 1);
            		ProcessAudit processAudit1 = new ProcessAudit();
            		processAudit1.setResult(0);
            		processAuditMapper.update(processAudit1, ew);
            		//新增
            		processAudit.setResult(1);//第一条数据 保存并审批  1是0否
            		processAudit.setProcessId(processId);
                }
            }else{
            	processAudit.setResult(0);// 保存并审批  1是0否
                processAudit.setProcessId(uuId); //多条数据时，流程标识取第一条的
            }
            processAuditMapper.insert(processAudit);
            if(type.equals("sbwx") || type.equals("sbbf") || type.equals("sbly") || type.equals("sbgh")){
            	//修改器材库的状态
            	EquipmentStroe entity = new EquipmentStroe();
            	entity.setId(equipmentId);
            	if(type.equals("sbwx")){
            		entity.setState(1);
            	}else if(type.equals("sbbf")){
            		entity.setState(2);
            	}else{
            		entity.setState(0);
            	}
            	quipmentStroeServicee.updateById(entity);
            }
        }
        
        /*
         * 推送通知数据
         */
        SendNoticeVO sendNoticeVO = new SendNoticeVO();
        SysNoticeVO sysNoticeVO = new SysNoticeVO();
        Map<Integer, String> users = new HashMap<Integer, String>();
        sysNoticeVO.setNoticeType(InformModel.DAIBAN.getcode());//申请的时候推送  通知类型：10系统、20待办、30审批通过、40审批不通过、50警告
        Date date = new Date();
        sysNoticeVO.setNoticeTime(date);
        if (type.equals("tf")) {
        	sysNoticeVO.setTitle(EnumProcessModel.tf.getName());
        	sysNoticeVO.setNoticeModule("tf");
        }else if(type.equals("yjcg")){
        	sysNoticeVO.setTitle(EnumProcessModel.yjcg.getName());
        	sysNoticeVO.setNoticeModule("yjcg");
        }else if(type.equals("yjly")){
        	sysNoticeVO.setTitle(EnumProcessModel.yjly.getName());
        	sysNoticeVO.setNoticeModule("yjly");
        }else if(type.equals("xzjh")){
        	sysNoticeVO.setTitle(EnumProcessModel.xzjh.getName());
        	sysNoticeVO.setNoticeModule("xzjh");
        }else if(type.equals("xzsq")){
        	sysNoticeVO.setTitle(EnumProcessModel.xzsq.getName());
        	sysNoticeVO.setNoticeModule("xzsq");
        }else if(type.equals("sswxjh")){
        	sysNoticeVO.setTitle(EnumProcessModel.sswxjh.getName());
        	sysNoticeVO.setNoticeModule("sswxjh");
        }else if(type.equals("sswxys")){
        	sysNoticeVO.setTitle(EnumProcessModel.sswxys.getName());
        	sysNoticeVO.setNoticeModule("sswxys");
        }else if(type.equals("sbcg")){
        	sysNoticeVO.setTitle(EnumProcessModel.sbcg.getName());
        	sysNoticeVO.setNoticeModule("sbcg");
        }else if(type.equals("sbwx")){
        	sysNoticeVO.setTitle(EnumProcessModel.sbwx.getName());
        	sysNoticeVO.setNoticeModule("sbwx");
        }else if(type.equals("sbly")){
        	sysNoticeVO.setTitle(EnumProcessModel.sbly.getName());
        	sysNoticeVO.setNoticeModule("sbly");
        }else if(type.equals("sbgh")){
        	sysNoticeVO.setTitle(EnumProcessModel.sbgh.getName());
        	sysNoticeVO.setNoticeModule("sbgh");
        }else if(type.equals("sbbf")){
        	sysNoticeVO.setTitle(EnumProcessModel.sbbf.getName());
        	sysNoticeVO.setNoticeModule("sbbf");
        }
        
        //根据仓房id获取仓房名称
        String houseName = "";
        if(houseId != null && houseId != 0){
        	ResponseEntity<String> forEntity = restTemplate.getForEntity(MyConstant.SYSTEM_WAREHOUSE + houseId, String.class);
        	if(null != forEntity && null != forEntity.getBody()){
        		com.alibaba.fastjson.JSONObject jsonObject = JSON.parseObject(forEntity.getBody());
                BasicsWarehouse ware = com.alibaba.fastjson.JSONObject.toJavaObject(jsonObject, BasicsWarehouse.class);
                if (null != ware) {
                    sysNoticeVO.setWarehouse(ware.gethName());
                    houseName = ware.gethName() ;
                }
        	}
            
        }
        
        //获取申请人的信息
        ResponseEntity<String> userInfos = restTemplate.getForEntity(MyConstant.SYSTEM_USER + applyPeople, String.class);
        if(null != userInfos && null != userInfos.getBody()){
        	com.alibaba.fastjson.JSONObject jsonObjectuser = JSON.parseObject(userInfos.getBody());
            SysUserPO userInfo = com.alibaba.fastjson.JSONObject.toJavaObject(jsonObjectuser, SysUserPO.class);
            //赋值
            if (null != userInfo) {
            	sysNoticeVO.setApplyName(userInfo.getPersonnelName());//公司
                sysNoticeVO.setOrgName(userInfo.getDepotName());//申请人
                sysNoticeVO.setApplyDept(userInfo.getDepartmentName());//申请部门
                sysNoticeVO.setCreateBy(applyPeople);
                sysNoticeVO.setContent(userInfo.getDepotName()+"-"+houseName+"-"+"待审批");
            }
            sendNoticeVO.setSysNoticeVO(sysNoticeVO);
        }
        
        ResponseEntity<String> userInfos1 = restTemplate.getForEntity(MyConstant.SYSTEM_USER + toPeople, String.class);
        if(null != userInfos1 && null != userInfos1.getBody()){
        	com.alibaba.fastjson.JSONObject jsonObjectuser1 = JSON.parseObject(userInfos1.getBody());
            SysUserPO userInfo1 = com.alibaba.fastjson.JSONObject.toJavaObject(jsonObjectuser1, SysUserPO.class);
            users.put(toPeople, userInfo1.getuName());
            sendNoticeVO.setUsers(users);
        }
        
        ResultView resultView = messageFeign.sendNotice(sendNoticeVO);
    }


    @Override
    public Page<ProcessAudit> getPage(PageParam pageParam) throws JSONException {
        // TODO Auto-generated method stub
        Integer pageIndex = pageParam.getPageIndex();
        Integer pageSize = pageParam.getPageSize();
        QueryWrapper<ProcessAudit> ew = new QueryWrapper<>();
        
        if (!StringUtils.isEmpty(pageParam.getCondition())) {
            org.json.JSONObject object = new org.json.JSONObject(pageParam.getCondition());
            Integer equipmentId = object.optInt("equipmentId");
            String startTime = object.optString("startTime");
            String endTime = object.optString("endTime");
            String type = object.optString("type");
            String houseId = object.optString("houseId");
            String depotId = object.optString("depotId");
            
            if("" != equipmentId+"" && equipmentId != 0){
            	//ew.eq("equipment_id", equipmentId);
            	ew.and(x -> x.eq("equipment_id", equipmentId).eq("result", 1).or().eq("equipment_id", equipmentId).eq("result", 2));
            }else{
            	if (StringUtils.isNotBlank(type)) {
                	if(type.equals("xz") || type.equals("sswx") || type.equals("sbly")){
                		ew.like("type",type);
                		ew.eq("result", 1);//取第一条数据
                	}else{
                		ew.eq("type", type);
                        if(type.equals("yjbg")){//药剂保管
                        	ew.eq("result", 2);//药剂保管d第一条数据
                        }else{
                        	ew.eq("result", 1);//取第一条数据
                        }
                	}
                	
                }else{
                	ew.eq("result", 1);//取第一条数据
                }
            }
            
            if (StringUtils.isNotBlank(houseId)) {
                ew.eq("house_id", houseId);
            }
            if (StringUtils.isNotBlank(depotId)) {
                ew.eq("depot_id", depotId);
            }

            if (StringUtils.isNotBlank(startTime) || StringUtils.isNotBlank(endTime)) {
                if (StringUtils.isNotBlank(startTime) && StringUtils.isNotBlank(endTime) &&
                        startTime.equals(endTime)) {
                    ew.apply("date_format(apply_time,'%Y-%m-%d')='" + startTime + "'");
                } else {
                    ew.between("apply_time", startTime, endTime);
                }
            }

        }

        ew.orderByDesc("id");
        Page page = new Page();
        if (pageIndex != MyConstant.ZERO && pageSize != MyConstant.ZERO) {
            page = new Page(pageIndex, pageSize);
        }

        Page<ProcessAudit> pageInfo = processAuditMapper.selectPage(page, ew);
        return pageInfo;
    }


    //noUse
/*@Override
    public List<Map<String, Object>> getAllById(Integer id) {
        // TODO Auto-generated method stub
        List<Map<String, Object>> list1 = new ArrayList<>();
        //通过审批第一条数据的id查询所有数据
        ProcessAudit processAudit = processAuditMapper.selectById(id);
        //根据唯一的流程标识 获取该流程下的所有数据
        QueryWrapper<ProcessAudit> ew = new QueryWrapper<>();
        ew.eq("process_id", processAudit.getProcessId());

        List<ProcessAudit> list = processAuditMapper.selectList(ew);

        QueryWrapper<ProcessMain> ew1 = new QueryWrapper<>();
        if(list.get(0).getType().equals("xzjh") || list.get(0).getType().equals("xzsq")){
        	ew1.eq("type", "xz");
        }else{
        	ew1.eq("type", list.get(0).getType());
        }
        List<ProcessMain> mainList = processMainMapper.selectList(ew1);
        if(mainList.size()>0){
        	for (int i = 0; i < mainList.size(); i++) {
                QueryWrapper<ProcessSub> ew2 = new QueryWrapper<>();
                ew1.eq("zid", mainList.get(i).getId());
                List<ProcessSub> subList = processSubMapper.selectList(ew2);
                HashMap<String, Object> map = Maps.newHashMap();
                map.put("mainList", mainList.get(i));//主表数据
                map.put("subList", subList);//子表数据
                map.put("auditList", list);//业务数据
                list1.add(map);
            }
        }else{
        	QueryWrapper<ProcessSub> ew2 = new QueryWrapper<>();
            ew1.eq("type", list.get(0).getType());
            List<ProcessSub> subList = processSubMapper.selectList(ew2);
            HashMap<String, Object> map = Maps.newHashMap();
            map.put("subList", subList);//子表数据
            map.put("auditList", list);//业务数据
            list1.add(map);
        }

        return list1;
    }*/


    /**
     * 根据第一条数据的id获取该流程的流程id，删除所有数据
     */
    @Override
    public void deleteById(Integer id) {
        // TODO Auto-generated method stub
        ProcessAudit processAudit = processAuditMapper.selectById(id);
        QueryWrapper<ProcessAudit> ew = new QueryWrapper<>();
        ew.eq("process_id", processAudit.getProcessId());
        processAuditMapper.delete(ew);
    }


    @Override
    public Page<ProcessAudit> toDisposeList(PageParam pageParam) throws JSONException {
        // TODO Auto-generated method stub

        Integer pageIndex = pageParam.getPageIndex();
        Integer pageSize = pageParam.getPageSize();


        org.json.JSONObject object = new org.json.JSONObject(pageParam.getCondition());
        Integer userId = object.getInt("userId");
        QueryWrapper<ProcessAudit> ew = new QueryWrapper<>();
        if (StringUtils.isNotBlank(userId+"")) {
            ew.eq("to_people", userId);
            ew.eq("audit_state", 0);//已提交
            //ew.and(x->x.eq("audit_state", 0).or().isNull("audit_state"));
        }
        ew.orderByDesc("id");

        Page page = new Page();
        if (pageIndex != MyConstant.ZERO && pageSize != MyConstant.ZERO) {
            page = new Page(pageIndex, pageSize);
        }
        Page<ProcessAudit> pageInfo = processAuditMapper.selectPage(page, ew);
        if (pageInfo.getTotal() > 0) {
            for (ProcessAudit processAudit : pageInfo.getRecords()) {
                //根据仓房id获取仓房名称
            	if(null != processAudit.getHouseId()){
            		ResponseEntity<String> forEntity = restTemplate.getForEntity(MyConstant.SYSTEM_WAREHOUSE + processAudit.getHouseId(), String.class);
            		if(null != forEntity && null != forEntity.getBody()){
            			com.alibaba.fastjson.JSONObject jsonObject = JSON.parseObject(forEntity.getBody());
                        BasicsWarehouse ware = com.alibaba.fastjson.JSONObject.toJavaObject(jsonObject, BasicsWarehouse.class);
                        if (null != ware) {
                            processAudit.setHouseName(ware.gethName());
                        }
            		}
                    
            	}
                
                //获取申请人的信息
                ResponseEntity<String> userInfos = restTemplate.getForEntity(MyConstant.SYSTEM_USER + processAudit.getApplyPeople(), String.class);
                if(null != userInfos && null != userInfos.getBody()){
                	com.alibaba.fastjson.JSONObject jsonObjectuser = JSON.parseObject(userInfos.getBody());
                    SysUserPO userInfo = com.alibaba.fastjson.JSONObject.toJavaObject(jsonObjectuser, SysUserPO.class);
                    //赋值
                    if (null != userInfo) {
                        processAudit.setApplyName(userInfo.getPersonnelName());
                        processAudit.setCompanyName(userInfo.getDepotName());
                        processAudit.setDepartmentName(userInfo.getDepartmentName());
                    }
                }
            }
        }
        return pageInfo;
    }

    /**
     * 第一次审批的时候，更改数据的状态，并且增加一条数据用于下一个人审批
     * 第二次审批的时候，更改数据的状态
     */

    @Override
    public void audit(String parameter) {
    	com.alibaba.fastjson.JSONObject jsStr = com.alibaba.fastjson.JSONObject.parseObject(parameter);
         String id = jsStr.getString("id");//audit表的每一条数据的id
         Integer auditState = jsStr.getInteger("auditState");//审批的状态（1通过，2不通过）
         //Integer toPeople = jsStr.getInteger("toPeople"); //下一个审批人的id
         String auditTime = jsStr.getString("auditTime");
         String ongoingStep = jsStr.getString("ongoingStep");
         
         //判断是第一个人审批还是第二个人审批
         ProcessAudit processAudit = processAuditMapper.selectById(id);

         /**
          * 定义 推送
          */
         SendNoticeVO sendNoticeVO = new SendNoticeVO();
         SysNoticeVO sysNoticeVO = new SysNoticeVO();
         Map<Integer, String> users = new HashMap<Integer, String>();
         Date date = new Date();
         sysNoticeVO.setNoticeTime(date);
         if (processAudit.getType().equals("tf")) {
         	sysNoticeVO.setTitle(EnumProcessModel.tf.getName());
         	sysNoticeVO.setNoticeModule("tf");
         }else if(processAudit.getType().equals("yjcg")){
        	 sysNoticeVO.setTitle(EnumProcessModel.yjcg.getName());
          	 sysNoticeVO.setNoticeModule("yjcg");
         }else if(processAudit.getType().equals("yjly")){
        	 sysNoticeVO.setTitle(EnumProcessModel.yjly.getName());
          	 sysNoticeVO.setNoticeModule("yjly");
         }else if(processAudit.getType().equals("xzsq")){
        	 sysNoticeVO.setTitle(EnumProcessModel.xzsq.getName());
          	 sysNoticeVO.setNoticeModule("xzsq");
         }else if(processAudit.getType().equals("xzjh")){
        	 sysNoticeVO.setTitle(EnumProcessModel.xzjh.getName());
          	 sysNoticeVO.setNoticeModule("xzjh");
         }else if(processAudit.getType().equals("sswxjh")){
        	 sysNoticeVO.setTitle(EnumProcessModel.sswxjh.getName());
          	 sysNoticeVO.setNoticeModule("sswxjh");
         }else if(processAudit.getType().equals("sswxys")){
        	 sysNoticeVO.setTitle(EnumProcessModel.sswxys.getName());
          	 sysNoticeVO.setNoticeModule("sswxys");
         }else if(processAudit.getType().equals("sbcg")){
        	 sysNoticeVO.setTitle(EnumProcessModel.sbcg.getName());
          	 sysNoticeVO.setNoticeModule("sbcg");
         }else if(processAudit.getType().equals("sbwx")){
        	 sysNoticeVO.setTitle(EnumProcessModel.sbwx.getName());
          	 sysNoticeVO.setNoticeModule("sbwx");
         }else if(processAudit.getType().equals("sbly")){
        	 sysNoticeVO.setTitle(EnumProcessModel.sbly.getName());
          	 sysNoticeVO.setNoticeModule("sbly");
         }else if(processAudit.getType().equals("sbgh")){
        	 sysNoticeVO.setTitle(EnumProcessModel.sbgh.getName());
          	 sysNoticeVO.setNoticeModule("sbgh");
         }else if(processAudit.getType().equals("sbbf")){
        	 sysNoticeVO.setTitle(EnumProcessModel.sbbf.getName());
          	 sysNoticeVO.setNoticeModule("sbbf");
         }
         //根据仓房id获取仓房名称
         String houseName = "";
         if(null != processAudit.getHouseId()){
        	 ResponseEntity<String> forEntity = restTemplate.getForEntity(MyConstant.SYSTEM_WAREHOUSE + processAudit.getHouseId(), String.class);
        	 if(null != forEntity && null != forEntity.getBody()){
        		 com.alibaba.fastjson.JSONObject jsonObject = JSON.parseObject(forEntity.getBody());
                 BasicsWarehouse ware = com.alibaba.fastjson.JSONObject.toJavaObject(jsonObject, BasicsWarehouse.class);
                 if (null != ware) {
                     sysNoticeVO.setWarehouse(ware.gethName());
                     houseName = ware.gethName();
                 }
        	 }
         }
         
         //获取申请人的信息
         ResponseEntity<String> userInfos = restTemplate.getForEntity(MyConstant.SYSTEM_USER + processAudit.getApplyPeople(), String.class);
         SysUserPO userInfo = new SysUserPO();
         if(null != userInfos && null != userInfos.getBody()){
        	 com.alibaba.fastjson.JSONObject jsonObjectuser = JSON.parseObject(userInfos.getBody());
              userInfo = com.alibaba.fastjson.JSONObject.toJavaObject(jsonObjectuser, SysUserPO.class);
             //赋值
             if (null != userInfo) {
             	sysNoticeVO.setApplyName(userInfo.getPersonnelName());//公司
                 sysNoticeVO.setOrgName(userInfo.getDepotName());//申请人
                 sysNoticeVO.setApplyDept(userInfo.getDepartmentName());//申请部门
                 sysNoticeVO.setCreateBy(processAudit.getApplyPeople());
             }
         }
         
         
         if (processAudit.getResult().equals(1) && processAudit.getAuditState().equals(0)) { //审批状态 是0 而且是第一条数据  就是第一次审批
             //第一个人审批

        	 if(processAudit.getType().equals("sbly")){//设备领用 只有一级审批
        		 processAudit.setAuditState(auditState);
                 processAudit.setAuditTime(auditTime);
                 processAudit.setOngoingStep(ongoingStep);
                 processAuditMapper.updateById(processAudit); //更改此条数据的审批状态
                 
                 /**
                  * 发送通知数据给申请人
                  */

                 if((int) auditState >= 3 || (int) auditState ==1){
                 	sysNoticeVO.setNoticeType(InformModel.TONGGUO.getcode());//申请的时候推送  通知类型：10系统、20待办、30审批通过、40审批不通过、50警告
                 	sysNoticeVO.setContent(userInfo.getDepotName()+"-"+houseName+"-"+"审批通过");
                 }else if((int) auditState == 2){
                 	sysNoticeVO.setNoticeType(InformModel.BUTONGGUO.getcode());//申请的时候推送  通知类型：10系统、20待办、30审批通过、40审批不通过、50警告
                 	sysNoticeVO.setContent(userInfo.getDepotName()+"-"+houseName+"-"+"审批不通过");
                 }
                 users.put(processAudit.getApplyPeople(), userInfo.getuName());
                 
        	 }else{
        		//获取审批人
                 QueryWrapper<ProcessBasis> ew = new QueryWrapper<>();
                 ew.eq("type", processAudit.getType());
                 List<ProcessBasis> list = processBasisMapper.selectList(ew);
                 List<Integer> idList = new ArrayList<>();
                 for (ProcessBasis processBasis : list) {
                     idList.add(processBasis.getId());
                 }
                 QueryWrapper<ProcessBasisSon> ew1 = new QueryWrapper<>();
                 ew1.eq("depot_id", processAudit.getDepotId());
                 ew1.in("zid", idList);
                 List<ProcessBasisSon> sonList = processBasisSonMapper.selectList(ew1);
                 Integer toPeople = 0;
                 for (int i = 0; i < sonList.size(); i++) {
                     if (sonList.get(i).getContent().equals(processAudit.getToPeople())) {
                         toPeople = sonList.get(i + 1).getContent();//下一个审批人的id
                         break;
                     }
                 }

                 processAudit.setAuditState(auditState);
                 processAudit.setAuditTime(auditTime);
                 processAuditMapper.updateById(processAudit); //更改此条数据的审批状态
                 if (auditState.equals(1)) {//1审批通过:,2:审批不通过
                     ProcessAudit processAudit1 = new ProcessAudit();
                     processAudit1.setMainId(processAudit.getMainId());
                     //processAudit1.setAuditState(auditState);
                     //processAudit1.setOperationTime(processAudit.getOperationTime());
                     processAudit1.setType(processAudit.getType());
                     processAudit1.setHouseId(processAudit.getHouseId());
                     processAudit1.setDepotId(processAudit.getDepotId());
                     processAudit1.setFromPeople(processAudit.getToPeople());//当前审批人是下一个审批的提交人
                     processAudit1.setToPeople(toPeople);
                     processAudit1.setResult(0);
                     processAudit1.setAuditState(0);//已提交待审批
                     processAudit1.setApplyPeople(processAudit.getApplyPeople());
                     processAudit1.setProcessId(processAudit.getProcessId());
                     processAudit1.setApplyTime(processAudit.getApplyTime());
                     processAudit1.setOngoingStep(ongoingStep);
                     if (processAudit.getType().equals("tf")) {
                         processAudit1.setWorkName(EnumProcessModel.tf.getName());
                     }else if(processAudit.getType().equals("yjcg")){
                    	 processAudit1.setWorkName(EnumProcessModel.yjcg.getName());
                     }else if(processAudit.getType().equals("yjly")){
                    	 processAudit1.setWorkName(EnumProcessModel.yjly.getName());
                     }else if(processAudit.getType().equals("xzsq")){
                    	 processAudit1.setWorkName(EnumProcessModel.xzsq.getName());
                     }else if(processAudit.getType().equals("xzjh")){
                    	 processAudit1.setWorkName(EnumProcessModel.xzjh.getName());
                     }else if(processAudit.getType().equals("sswxjh")){
                    	 processAudit1.setWorkName(EnumProcessModel.sswxjh.getName());
                     }else if(processAudit.getType().equals("sswxys")){
                    	 processAudit1.setWorkName(EnumProcessModel.sswxys.getName());
                     }else if(processAudit.getType().equals("sbcg")){
                    	 processAudit1.setWorkName(EnumProcessModel.sbcg.getName());
                     }else if(processAudit.getType().equals("sbwx")){
                    	 processAudit1.setWorkName(EnumProcessModel.sbwx.getName());
                     }else if(processAudit.getType().equals("sbbf")){
                    	 processAudit1.setWorkName(EnumProcessModel.sbbf.getName());
                     }else if(processAudit.getType().equals("sbly")){
                    	 processAudit1.setWorkName(EnumProcessModel.sbly.getName());
                     }else if(processAudit.getType().equals("sbgh")){
                    	 processAudit1.setWorkName(EnumProcessModel.sbgh.getName());
                     }
                     processAuditMapper.insert(processAudit1);
                     
                     /**
                      *  发送通知数据给下一审批人
                      */
                     sysNoticeVO.setContent(userInfo.getDepotName()+"-"+houseName+"-"+"待审批");
                     sysNoticeVO.setNoticeType(InformModel.TONGGUO.getcode());//申请的时候推送  通知类型：10系统、20待办、30审批通过、40审批不通过、50警告
                    //获取下一审批人的信息
                     ResponseEntity<String> userInfos1 = restTemplate.getForEntity(MyConstant.SYSTEM_USER + toPeople, String.class);
                     if(null != userInfos1 && null != userInfos1.getBody()){
                    	 com.alibaba.fastjson.JSONObject jsonObjectuser1 = JSON.parseObject(userInfos1.getBody());
                         SysUserPO userInfo1 = com.alibaba.fastjson.JSONObject.toJavaObject(jsonObjectuser1, SysUserPO.class);
                         users.put(toPeople, userInfo1.getuName());
                     }
                 }else{//不通过 发送数据给申请人
                 	 sysNoticeVO.setContent(userInfo.getDepotName()+"-"+houseName+"-"+"审批不通过");
                     sysNoticeVO.setNoticeType(InformModel.BUTONGGUO.getcode());//申请的时候推送  通知类型：10系统、20待办、30审批通过、40审批不通过、50警告
                     users.put(processAudit.getApplyPeople(), userInfo.getuName());
                 }
        	 }
         } else {
             //第二个人审批
             //修改第一条数据的状态(历史数据的状态)
             if ((int) auditState >= 3) {
                 processAudit.setAuditState(1);
             } else {
                 processAudit.setAuditState(auditState);
             }
             processAudit.setAuditTime(auditTime);
             processAuditMapper.updateById(processAudit);
             //修改第二条数据的状态、进行到哪一步、审批时间(最新的数据)
             QueryWrapper<ProcessAudit> ew2 = new QueryWrapper<>();
             ew2.eq("process_id", processAudit.getProcessId());
             ew2.eq("type", processAudit.getType());
             ew2.eq("result", 1);//是第一条记录
             List<ProcessAudit> paList = processAuditMapper.selectList(ew2);
             paList.get(0).setAuditState(auditState);
             paList.get(0).setOngoingStep(ongoingStep);
             processAuditMapper.updateById(paList.get(0));
             
             /**
              * 发送通知数据给申请人
              */

             if((int) auditState >= 3 || (int) auditState ==1){
             	sysNoticeVO.setNoticeType(InformModel.TONGGUO.getcode());//申请的时候推送  通知类型：10系统、20待办、30审批通过、40审批不通过、50警告
             	sysNoticeVO.setContent(userInfo.getDepotName()+"-"+houseName+"-"+"审批通过");
             }else if((int) auditState == 2){
             	sysNoticeVO.setNoticeType(InformModel.BUTONGGUO.getcode());//申请的时候推送  通知类型：10系统、20待办、30审批通过、40审批不通过、50警告
             	sysNoticeVO.setContent(userInfo.getDepotName()+"-"+houseName+"-"+"审批不通过");
             }
             users.put(processAudit.getApplyPeople(), userInfo.getuName());
         }
         sendNoticeVO.setUsers(users);
         sendNoticeVO.setSysNoticeVO(sysNoticeVO);
         ResultView resultView = messageFeign.sendNotice(sendNoticeVO);
    }


    @Override
    public void detailsAdd(String parameter) throws JSONException {
        // TODO Auto-generated method stub
        //JSONObject jsStr = JSONObject.parseObject(parameter);
        JSONObject jsStr = new JSONObject(parameter);
        String processId = jsStr.optString("processId");//流程id 每一条明细都是和第一条保存提交的流程id一样
        String type = jsStr.optString("type");//流程类型
        //Integer mainId = jsStr.getInteger("mainId");//主流程id
        //Integer houseId = jsStr.getInteger("houseId");//仓房id
        //Integer depotId = jsStr.getInteger("depotId");//库id
        //Integer applyPeople = jsStr.getInteger("applyPeople");//申请人id
        Integer auditState = jsStr.optInt("auditState");//审批状态
        JSONArray jsonArray = jsStr.optJSONArray("subList");//子流程数据
        String ongoingStep = jsStr.optString("ongoingStep");//进行到哪一步的主流程id
        //修改第一条数据 走到哪一步的状态
        QueryWrapper<ProcessAudit> ew = new QueryWrapper<>();
        ew.eq("process_id", processId);
        ew.eq("type", type);
        ew.eq("result", 1);//第一条记录
        List<ProcessAudit> paList = processAuditMapper.selectList(ew);
        paList.get(0).setOngoingStep(ongoingStep);
        paList.get(0).setAuditState(auditState);
        processAuditMapper.updateById(paList.get(0));
        JSONObject row = null;
        for (int i = 0; i < jsonArray.length(); i++) {
            row = jsonArray.getJSONObject(i);
            Integer mainId =  row.optInt("mainId");//主流程id
            Integer subId = row.optInt("subId");//子流程id
            Integer subData = row.optInt("subData");//子流程数据
            String operationTime = row.optString("operationTime");//子流程的操作时间
            QueryWrapper<ProcessAudit> ew1 = new QueryWrapper<>();
            ew1.eq("process_id", processId);
            ew1.eq("type", type);
            ew1.eq("sub_id", subId);
            List<ProcessAudit> list = processAuditMapper.selectList(ew1);
            if (list.size() > 0) {
                //修改
                if (!list.get(0).getSubData().equals(subData)) {
                    list.get(0).setSubData(subData);
                    list.get(0).setOperationTime(operationTime);
                    processAuditMapper.updateById(list.get(0));
                }
            } else {
                //新增
                ProcessAudit processAudit = new ProcessAudit();
                processAudit.setType(type);
                processAudit.setMainId(mainId);
                processAudit.setSubId(subId);
                processAudit.setSubData(subData);
                processAudit.setOperationTime(operationTime);
                //processAudit.setHouseId(houseId);
                //processAudit.setDepotId(depotId);
                //processAudit.setApplyPeople(applyPeople);
                processAudit.setResult(0);//第一条数据 保存并审批  1是0否
                processAudit.setProcessId(processId);
                //processAudit.setAuditState(auditState);
                processAuditMapper.insert(processAudit);
            }

        }
    }


    @Override
    public Map<String, Object> getDataByProcessId(String processId) {
        // TODO Auto-generated method  stub
        HashMap<String, Object> map = Maps.newHashMap();
       
        List<ProcessAudit> list2 = new ArrayList<ProcessAudit>();

        //根据唯一的流程标识 获取该流程下的所有数据
        QueryWrapper<ProcessAudit> ew = new QueryWrapper<>();
        ew.eq("process_id", processId);
        ew.isNotNull("to_people");
        ew.isNotNull("from_people");
        List<ProcessAudit> list = processAuditMapper.selectList(ew);
        
        QueryWrapper<ProcessAudit> we = new QueryWrapper<>();
        we.eq("process_id", processId);
        List<ProcessAudit> sonList = processAuditMapper.selectList(we);
        //map.put("data", list);
        
        int depot = 0;
        int ongoingStep = 0;
        
        if(list.size()>0 && (list.get(0).getType().equals("xzjh") || list.get(0).getType().equals("xzsq") || 
        		list.get(0).getType().equals("sswxjh") || list.get(0).getType().equals("sswxys") ||
        		list.get(0).getType().equals("sbly") || list.get(0).getType().equals("sbgh"))){
            if(list.size()>0){
            	 depot = list.get(0).getDepotId();
                 ongoingStep = Integer.valueOf(list.get(0).getOngoingStep());
                 
                 //如果是多流程 则把审批数据分开
                 if(list.get(0).getResult() == 0){ //如果是多流程 则把审批数据分开
                	int index = 0;
                 	for (int i = 0; i < list.size(); i++) {
                     	if(list.get(i).getResult() == 1){
                     		index = i;
                     		break;
                     	}
             		}
                 	for (int i = 0; i < list.size(); i++) {
 						if( i >= index){
 							list2.add(list.get(i));
 						}
 					}
	                 if(list2.size()>0){
	                	 depot = list2.get(0).getDepotId();
	                     ongoingStep = Integer.valueOf(list2.get(0).getOngoingStep());
	                 }
                 }
                	
            }
        }

        //流程基础数据
        List<Map<String, Object>> process = new ArrayList<>();
        QueryWrapper<ProcessMain> ew1 = new QueryWrapper<>();
        if(list.size()>0){
        	if(list.get(0).getType().equals("xzjh") || list.get(0).getType().equals("xzsq")){
            	ew1.eq("type", "xz");
            }else if(list.get(0).getType().equals("sswxjh") || list.get(0).getType().equals("sswxys")){
            	ew1.eq("type", "sswx");
            }else if(list.get(0).getType().equals("sbly") || list.get(0).getType().equals("sbgh")){
            	ew1.eq("type", "sbly");
            }else{
            	ew1.eq("type", list.get(0).getType());
            }
        }else{
        	ew1.eq("type", sonList.get(0).getType());
        }
        
        
        boolean auditFirst = true; 
        List<ProcessMain> mainList = processMainMapper.selectList(ew1);
        if(mainList.size()>0){
        	for (int i = 0; i < mainList.size(); i++) {
        		//是否是总经理和分管处审批
        		QueryWrapper<ProcessAudit> e = new QueryWrapper<>();
                e.eq("process_id", processId);
                e.eq("main_id", mainList.get(i).getId());
                List<ProcessAudit> auditList = processAuditMapper.selectList(e);
                if(auditList.size()>0){
                	mainList.get(i).setIsAudit(auditList.get(0).getIsAudit());
                }
                QueryWrapper<ProcessSub> ew2 = new QueryWrapper<>();
                ew2.eq("zid", mainList.get(i).getId());
                List<ProcessSub> subList = processSubMapper.selectList(ew2);
                for (int j = 0; j < subList.size(); j++) {
                    for (int k = 0; k < sonList.size(); k++) {
                        if (subList.get(j).getId().equals(sonList.get(k).getSubId())) {
                            subList.get(j).setOperationTime(sonList.get(k).getOperationTime());
                            subList.get(j).setSubData(sonList.get(k).getSubData());
                        }
                    }
                }
                HashMap<String, Object> map1 = Maps.newHashMap();
                map1.put("step", mainList.get(i));//主表数据
                map1.put("list", subList);//子表数据
                if(list.size()>0 && (list.get(0).getType().equals("xzjh") || list.get(0).getType().equals("xzsq")
                		|| list.get(0).getType().equals("sswxjh") || list.get(0).getType().equals("sswxys")
                		|| list.get(0).getType().equals("sbly") || list.get(0).getType().equals("sbgh"))){
                    //审批人数据
                    if(mainList.get(i).getExistProcess().equals(0)){
                    	if(auditFirst){
                    		createAudit( mainList, list, i, map1, depot, ongoingStep);
                    		auditFirst = false;
                    	}else{
                        	createAudit( mainList, list2, i, map1,depot, ongoingStep);
                    	}
                    }
                }else{
                	//审批数据
                	if(mainList.get(i).getExistProcess().equals(0) && list.size()>0){
                    	List<ProcessBasis> pbList = processBasisService.getBasisByType(list.get(0).getType(), null, list.get(0).getDepotId());
                    	if(pbList.size()>0){
                    		//判断是否是通过
                           	boolean flag = list.get(0).getAuditState().equals(2);
                           	//保管员
                   			pbList.get(0).setAuditTime(list.get(0).getApplyTime());//保管员的时间为 申请时间
                   			pbList.get(0).setContent(list.get(0).getApplyPeople());//保管员为申请人
                   		 	for (int j = 0; j < pbList.size(); j++) {
                       		    if(j==0)continue;//保管员 不做处理
                       		    //审批人
                       		    ProcessBasis item = pbList.get(j);
                       			if(j-1<=list.size()-1){
                       				// 业务
                       				ProcessAudit audit = list.get(j-1);
                       				item.setAuditTime(audit.getAuditTime());
                       				item.setContent(audit.getToPeople());
                       				if(flag){//不通过
                               			if(j-1==list.size()-1){
                               				item.setAuditState(2);
                               			}else{
                               				item.setAuditState(1);
                               			}
                               		}else{
                               			item.setAuditState(audit.getAuditState());
                               		}
                       				
                       			}
               			    }
                   		  if(pbList.get(1).getAuditState().equals(4) || pbList.get(1).getAuditState().equals(3)){
                        		pbList.get(1).setAuditState(1);
                          }
                   		   map1.put("audit", pbList);
                    	}
                	}
                }
                process.add(map1);
                
            }
        }else{
        	HashMap<String, Object> map1 = Maps.newHashMap();
        	QueryWrapper<ProcessSub> ew2 = new QueryWrapper<>();
            ew2.eq("type", sonList.get(0).getType());
            List<ProcessSub> subList = processSubMapper.selectList(ew2);
            for (int j = 0; j < subList.size(); j++) {
                for (int k = 0; k < sonList.size(); k++) {
                    if (subList.get(j).getId().equals(sonList.get(k).getSubId())) {
                        subList.get(j).setOperationTime(sonList.get(k).getOperationTime());
                        subList.get(j).setSubData(sonList.get(k).getSubData());
                        subList.get(j).setAuditId(sonList.get(k).getId());
                    }
                }
            }
            map1.put("list", subList);//子表数据
            
          //审批流程信息
            if(list.size()>0 && (list.get(0).getType().equals("tf") || list.get(0).getType().equals("yjly") || list.get(0).getType().equals("yjcg")
            		|| list.get(0).getType().equals("sbcg"))){
            	List<ProcessBasis> pbList = processBasisService.getBasisByType(list.get(0).getType(), null, list.get(0).getDepotId());
                if(pbList.size()>0){
                	if(pbList.get(0).getType().equals("tf") || pbList.get(0).getType().equals("yjly")){
                   	 pbList.get(0).setAuditTime(list.get(0).getApplyTime());
                        pbList.get(0).setContent(list.get(0).getApplyPeople());
                        if (list.get(0).getAuditState().equals(0)) {
                            //已申请，待第一个人审批
                            pbList.get(1).setAuditState(0);
                            pbList.get(1).setContent(list.get(0).getToPeople());
                        } else {
                            //已审批
                            pbList.get(1).setContent(list.get(0).getToPeople());
                            pbList.get(1).setAuditTime(list.get(0).getAuditTime());
                            if ((int) list.get(0).getAuditState() >= 3) {
                                pbList.get(1).setAuditState(1);
                            } else if (list.size() > 1 && list.get(0).getAuditState().equals(2)) {//两次审批 第一次通过 第二次不通过 第一条数据的状态是最新的2 则展示通过
                                pbList.get(1).setAuditState(1);
                            } else {
                                pbList.get(1).setAuditState(list.get(0).getAuditState());
                            }
                            if (list.size() > 1) {
                                pbList.get(2).setContent(list.get(1).getToPeople());
                                pbList.get(2).setAuditTime(list.get(1).getAuditTime());
                                pbList.get(2).setAuditState(list.get(1).getAuditState());
                            }
                        }
                   }else{
                   	
                   	//判断是否是通过
                   	boolean flag = list.get(0).getAuditState().equals(2);
                   	//保管员
           			pbList.get(0).setAuditTime(list.get(0).getApplyTime());//保管员的时间为 申请时间
           			pbList.get(0).setContent(list.get(0).getApplyPeople());//保管员为申请人
                   	for (int j = 0; j < pbList.size(); j++) {
                   		    if(j==0)continue;//保管员 不做处理
                   		    //审批人
                   		    ProcessBasis item = pbList.get(j);
                   			if(j-1<=list.size()-1){
                   				// 业务
                   				ProcessAudit audit = list.get(j-1);
                   				item.setAuditTime(audit.getAuditTime());
                   				item.setContent(audit.getToPeople());
                   				if(flag){//不通过
                           			if(j-1==list.size()-1){
                           				item.setAuditState(2);
                           			}else{
                           				item.setAuditState(1);
                           			}
                           		}else{
                           			item.setAuditState(audit.getAuditState());
                           		}
                   				
                   			}
           			}
                   	if(pbList.get(1).getAuditState().equals(4) || pbList.get(1).getAuditState().equals(3)){
                   		pbList.get(1).setAuditState(1);
                   	}
                   	
                   }
                	map1.put("audit", pbList);
                }
            }
            
            process.add(map1);
        }
        
        map.put("process", process);

        //审批流程信息
        if(list.size()>0 && (list.get(0).getType().equals("tf") || list.get(0).getType().equals("yjly") || list.get(0).getType().equals("yjcg")
        		|| list.get(0).getType().equals("sbcg"))){
        	List<ProcessBasis> pbList = processBasisService.getBasisByType(list.get(0).getType(), null, list.get(0).getDepotId());
            if(pbList.size()>0){
            	if(pbList.get(0).getType().equals("tf") || pbList.get(0).getType().equals("yjly")){
               	 pbList.get(0).setAuditTime(list.get(0).getApplyTime());
                    pbList.get(0).setContent(list.get(0).getApplyPeople());
                    if (list.get(0).getAuditState().equals(0)) {
                        //已申请，待第一个人审批
                        pbList.get(1).setAuditState(0);
                        pbList.get(1).setContent(list.get(0).getToPeople());
                    } else {
                        //已审批
                        pbList.get(1).setContent(list.get(0).getToPeople());
                        pbList.get(1).setAuditTime(list.get(0).getAuditTime());
                        if ((int) list.get(0).getAuditState() >= 3) {
                            pbList.get(1).setAuditState(1);
                        } else if (list.size() > 1 && list.get(0).getAuditState().equals(2)) {//两次审批 第一次通过 第二次不通过 第一条数据的状态是最新的2 则展示通过
                            pbList.get(1).setAuditState(1);
                        } else {
                            pbList.get(1).setAuditState(list.get(0).getAuditState());
                        }
                        if (list.size() > 1) {
                            pbList.get(2).setContent(list.get(1).getToPeople());
                            pbList.get(2).setAuditTime(list.get(1).getAuditTime());
                            pbList.get(2).setAuditState(list.get(1).getAuditState());
                        }
                    }
               }else{
               	
               	//判断是否是通过
               	boolean flag = list.get(0).getAuditState().equals(2);
               	//保管员
       			pbList.get(0).setAuditTime(list.get(0).getApplyTime());//保管员的时间为 申请时间
       			pbList.get(0).setContent(list.get(0).getApplyPeople());//保管员为申请人
               	for (int j = 0; j < pbList.size(); j++) {
               		    if(j==0)continue;//保管员 不做处理
               		    //审批人
               		    ProcessBasis item = pbList.get(j);
               			if(j-1<=list.size()-1){
               				// 业务
               				ProcessAudit audit = list.get(j-1);
               				item.setAuditTime(audit.getAuditTime());
               				item.setContent(audit.getToPeople());
               				if(flag){//不通过
                       			if(j-1==list.size()-1){
                       				item.setAuditState(2);
                       			}else{
                       				item.setAuditState(1);
                       			}
                       		}else{
                       			item.setAuditState(audit.getAuditState());
                       		}
               				
               			}
       			}
               	if(pbList.get(1).getAuditState().equals(4) || pbList.get(1).getAuditState().equals(3)){
               		pbList.get(1).setAuditState(1);
               	}
               	
               }
            	map.put("audit", pbList);
            }
        }
        return map;
    }


    @Override
    public Page<ProcessAudit> applyList(PageParam pageParam) throws JSONException {
        // TODO Auto-generated method stub

        Integer pageIndex = pageParam.getPageIndex();
        Integer pageSize = pageParam.getPageSize();

        QueryWrapper<ProcessAudit> ew = new QueryWrapper<>();
        org.json.JSONObject object = new org.json.JSONObject(pageParam.getCondition());
        String userId = object.optString("userId");

        if (StringUtils.isNotBlank(userId)) {
            ew.eq("apply_people", userId);
            ew.eq("from_people", userId);
        }
        //ew.eq("result", 1);//整个流程的第一条数据
        //只获取审批的数据
        ew.isNotNull("to_people");
        ew.orderByDesc("id");

        Page page = new Page();
        if (pageIndex != MyConstant.ZERO && pageSize != MyConstant.ZERO) {
            page = new Page(pageIndex, pageSize);
        }

        Page<ProcessAudit> pageInfo = processAuditMapper.selectPage(page, ew);


        if (pageInfo.getTotal() > 0) {
            for (ProcessAudit processAudit : pageInfo.getRecords()) {
                //根据仓房id获取仓房名称
            	if(null != processAudit.getHouseId()){
            		ResponseEntity<String> forEntity = restTemplate.getForEntity(MyConstant.SYSTEM_WAREHOUSE + processAudit.getHouseId(), String.class);
            		if(null != forEntity && null != forEntity.getBody()){
            			com.alibaba.fastjson.JSONObject jsonObject = JSON.parseObject(forEntity.getBody());
                        BasicsWarehouse ware = com.alibaba.fastjson.JSONObject.toJavaObject(jsonObject, BasicsWarehouse.class);
                        if (null != ware) {
                            processAudit.setHouseName(ware.gethName());
                        }
            		}
                    
            	}
                
                //获取申请人的信息
                ResponseEntity<String> userInfos = restTemplate.getForEntity(MyConstant.SYSTEM_USER + processAudit.getApplyPeople(), String.class);
                if(null != userInfos && null != userInfos.getBody()){
                	com.alibaba.fastjson.JSONObject jsonObjectuser = JSON.parseObject(userInfos.getBody());
                    SysUserPO userInfo = com.alibaba.fastjson.JSONObject.toJavaObject(jsonObjectuser, SysUserPO.class);
                    //赋值
                    if (null != userInfo) {
                        processAudit.setApplyName(userInfo.getPersonnelName());
                        processAudit.setCompanyName(userInfo.getDepotName());
                        processAudit.setDepartmentName(userInfo.getDepartmentName());
                    }
                }
            }
        }

        return pageInfo;
    }


    @Override
    public Page<ProcessAudit> completeList(PageParam pageParam) throws JSONException {
        // TODO Auto-generated method stub

        Integer pageIndex = pageParam.getPageIndex();
        Integer pageSize = pageParam.getPageSize();


        QueryWrapper<ProcessAudit> ew = new QueryWrapper<>();
        org.json.JSONObject object = new org.json.JSONObject(pageParam.getCondition());
        String userId = object.optString("userId");
        if (StringUtils.isNotBlank(userId)) {
            //如果是第一个审批人 则第一条数据中状态不为0(提交)
            ew.eq("to_people", userId);
            //ew.eq("result",1);//整个流程的第一条数据
            //ew.ne("audit_state",0);

            //第二个人审批 审批状态为2 3 (XX 第一条数据的状态是,2:审批不通过，3:审批完成进行中)

            ew.and(x -> x.eq("result", 1).ne("audit_state", 0).or().ne("result", 1).between("audit_state", 1, 3));


        }

        ew.orderByDesc("id");
        Page page = new Page();
        if (pageIndex != MyConstant.ZERO && pageSize != MyConstant.ZERO) {
            page = new Page(pageIndex, pageSize);
        }
        Page<ProcessAudit> pageInfo = processAuditMapper.selectPage(page, ew);
        if (pageInfo.getTotal() > 0) {
            for (ProcessAudit processAudit : pageInfo.getRecords()) {
            	//赋值状态
            	QueryWrapper<ProcessAudit> ew1 = new QueryWrapper<>();
            	ew1.eq("from_people", processAudit.getApplyPeople());
            	ew1.eq("process_id", processAudit.getProcessId());
            	ew1.eq("type", processAudit.getType());
            	List<ProcessAudit> list = processAuditMapper.selectList(ew1);
            	if(list.size()>0){
            		for (ProcessAudit processAudit2 : list) {
						if(processAudit2.getAuditState() != processAudit.getAuditState()){
							processAudit.setAuditState(processAudit2.getAuditState());
						}
					}
            	}
            	
                //根据仓房id获取仓房名称
            	if(null != processAudit.getHouseId()){
            		ResponseEntity<String> forEntity = restTemplate.getForEntity(MyConstant.SYSTEM_WAREHOUSE + processAudit.getHouseId(), String.class);
            		if(null != forEntity && null != forEntity.getBody()){
            			com.alibaba.fastjson.JSONObject jsonObject = JSON.parseObject(forEntity.getBody());
                        BasicsWarehouse ware = com.alibaba.fastjson.JSONObject.toJavaObject(jsonObject, BasicsWarehouse.class);
                        if (null != ware) {
                            processAudit.setHouseName(ware.gethName());
                        }
            		}
            	}
                
                //获取申请人的信息
                ResponseEntity<String> userInfos = restTemplate.getForEntity(MyConstant.SYSTEM_USER + processAudit.getApplyPeople(), String.class);
                if(null != userInfos && null != userInfos.getBody()){
                	com.alibaba.fastjson.JSONObject jsonObjectuser = JSON.parseObject(userInfos.getBody());
                    SysUserPO userInfo = com.alibaba.fastjson.JSONObject.toJavaObject(jsonObjectuser, SysUserPO.class);
                    //赋值
                    if (null != userInfo) {
                        processAudit.setApplyName(userInfo.getPersonnelName());
                        processAudit.setCompanyName(userInfo.getDepotName());
                        processAudit.setDepartmentName(userInfo.getDepartmentName());
                    }
                }
            }
        }
        return pageInfo;
    }

    @Override
    public List<ToBeDoneCallbackVO> toBeDone(ProcessToBeDone processToBeDone) {
        List<ToBeDoneCallbackVO> result = new ArrayList<>();

        String usersInfo = processToBeDone.getUsersInfo();
        Integer levelDepotHouse = processToBeDone.getLevelDepotHouse();
        if (StringUtils.isNotEmpty(usersInfo)) {
            String[] userInfoArr = usersInfo.split(",");
            for (String userInfo : userInfoArr) {
                String[] temp = userInfo.split("\\|");
                Integer userId = Integer.parseInt(temp[0]);
                SysUserDTO user = systemFeign.getUserById(userId);
                if(1 == levelDepotHouse) {//预警到库级
                    toBeDoneDetails(result, processToBeDone, user, null, null);
                } else if(2 == levelDepotHouse) {//预警到仓房级
                    String storehouseIds = user.getStorehouseIds();
                    String storehouseNames = user.getStorehouseNames();
                    if (StringUtils.isNotEmpty(storehouseIds)) {
                        String[] houseIdArr = storehouseIds.split(",");
                        String[] houseNameArr = storehouseNames.split(",");
                        for (int i = 0; i < houseIdArr.length; i++) {
                            Integer houseId = Integer.parseInt(houseIdArr[i]);
                            String houseName = houseNameArr[i];
                            toBeDoneDetails(result, processToBeDone, user, houseId, houseName);
                        }
                    }
                }
            }
        }

        return result;
    }

    private void toBeDoneDetails(List<ToBeDoneCallbackVO> result,
                                 ProcessToBeDone processToBeDone,
                                 SysUserDTO user,
                                 Integer houseId,
                                 String houseName) {
        ProcessToBeDoneVO toBeDoneVO = new ProcessToBeDoneVO();
        toBeDoneVO.setTitle(processToBeDone.getTitle());
        toBeDoneVO.setHouseId(houseId);
        toBeDoneVO.setDepotId(user.getDepotId());
        toBeDoneVO.setStartDate(processToBeDone.getStartDate());
        toBeDoneVO.setEndDate(processToBeDone.getEndDate());
        toBeDoneVO.setToPage(processToBeDone.getToPage());
        toBeDoneVO.setUserId(user.getUId());
        toBeDoneVO.setType(processToBeDone.getType());
        //
        ProcessAudit processAudit = toBeDone(toBeDoneVO);//生成待办数据
        //
        ToBeDoneCallbackVO toBeDoneCallbackVO = new ToBeDoneCallbackVO();
        toBeDoneCallbackVO.setToBeDoneId(processAudit.getId());
        toBeDoneCallbackVO.setUserId(user.getUId());
        toBeDoneCallbackVO.setPersonnelName(user.getPersonnelName());
        toBeDoneCallbackVO.setDepotId(user.getDepotId());
        toBeDoneCallbackVO.setDepotName(user.getDepotName());
        toBeDoneCallbackVO.setHouseId(houseId);
        toBeDoneCallbackVO.setHouseName(houseName);

        result.add(toBeDoneCallbackVO);
    }



    private ProcessAudit toBeDone(ProcessToBeDoneVO processToBeDone) {
        // TODO Auto-generated method stub
        ProcessAudit processAudit = new ProcessAudit();
        if (null != processToBeDone) {
            processAudit.setResult(1);//是首条记录
            processAudit.setAuditState(0);//提交待审批
            // 获得SimpleDateFormat类
            SimpleDateFormat sf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
//            processAudit.setApplyTime(sf.format(processToBeDone.getStartDate()));//申请时间

            processAudit.setApplyTime(sf.format(new Date()));//申请时间

            if (null != processToBeDone.getHouseId()) {//仓id
                processAudit.setHouseId(processToBeDone.getHouseId());
            }
            if (null != processToBeDone.getDepotId()) {//库id
                processAudit.setDepotId(processToBeDone.getDepotId());
            }
            if (null != processToBeDone.getType()) {//类型(例如:tf)
                processAudit.setType(processToBeDone.getType());
            }
            if (null != processToBeDone.getUserId()) {//待办人员ID
                processAudit.setToPeople(processToBeDone.getUserId());
                processAudit.setApplyPeople(processToBeDone.getUserId());
            }
            if (null != processToBeDone.getTitle()) {//流程名称，如 科长每2周粮情检查
                processAudit.setWorkName(processToBeDone.getTitle());
            }
            if (null != processToBeDone.getStartDate()) {//办理开始时间
                processAudit.setStartDate(processToBeDone.getStartDate());
            }
            if (null != processToBeDone.getEndDate()) {//办理结束时间
                processAudit.setEndDate(processToBeDone.getEndDate());
            }

            log.error("--------------------------------------------------------");
            log.error("--------------------------------------------------------");
            log.error("--------------------------------------------------------");
            log.error("--------------------------------------------------------");
            log.error("--------------------------------------------------------");
            log.error("--------------------------------------------------------");
            log.error("申请时间：" + processAudit.getApplyTime());
            log.error("开始时间：" + sf.format(processAudit.getStartDate()));
            log.error("结束时间：" + sf.format(processAudit.getEndDate()));
            log.error("--------------------------------------------------------");
            log.error("--------------------------------------------------------");
            log.error("--------------------------------------------------------");
            log.error("--------------------------------------------------------");
            log.error("--------------------------------------------------------");
            log.error("--------------------------------------------------------");
            log.error("--------------------------------------------------------");


            if (null != processToBeDone.getToPage()) {//办理页面url
                processAudit.setToPage(processToBeDone.getToPage());
            }
            processAuditMapper.insert(processAudit);
        }
        return processAudit;
    }


    @Override
    public void haveDone(Integer id, Integer auditState) {
        // TODO Auto-generated method stub
        ProcessAudit processAudit = processAuditMapper.selectById(id);
        if (null != processAudit) {
            if (processAudit.getAuditState().equals(4)) {//已经处理完成 则不处理
                haveDone(processAudit.getApplyPeople(), processAudit.getType(), processAudit.getDepotId(), processAudit.getHouseId(), auditState);
            } else {
                processAudit.setAuditState(auditState);//设置状态
                // 获得SimpleDateFormat类
                SimpleDateFormat sf = new SimpleDateFormat("yyyy-MM-dd HH:mm");
                processAudit.setOperationTime(sf.format(new Date()));//具体办理时的时间
                processAuditMapper.updateById(processAudit);
            }
        }

    }

    @Override
    public void haveDone(Integer userId, String type, Integer depotId, Integer houseId, Integer auditState) {
        // TODO Auto-generated method stub
        //根据用户id、流程类型(如科长每2周粮情检查的类型：xxxx1)，按时间倒序查出待办流程，将最近日期的流程设成已办
        //同时要存储具体办理时的时间，因为要计算该流程办理的周期(或计算逾期时间)
        QueryWrapper<ProcessAudit> ew = new QueryWrapper<>();
        ew.eq("to_people", userId);
        ew.eq("type", type);
        if(null != depotId) {
            ew.eq("depot_id", depotId);
        }
        if(null != houseId) {
            ew.eq("house_id", houseId);
        }
        ew.orderByDesc("start_date");//根据时间倒叙
        List<ProcessAudit> auditList = processAuditMapper.selectList(ew);
        if (auditList.size() > 0) {
            auditList.get(0).setAuditState(auditState);//设置状态
            // 获得SimpleDateFormat类
            SimpleDateFormat sf = new SimpleDateFormat("yyyy-MM-dd HH:mm");
            auditList.get(0).setOperationTime(sf.format(new Date()));//具体办理时的时间
            processAuditMapper.updateById(auditList.get(0));
        }
    }

    @Override
    public void haveDone(Integer userId, String type, Integer depotId, Integer auditState) {
        haveDone(userId, type, depotId, null, auditState);
    }

    @Override
    public List<Integer> getNotBeDoneNotice(String toBeDoneIds) {
        List<Integer> result = null;
        if (StringUtils.isNotEmpty(toBeDoneIds)) {
            String[] toBeDoneIdArr = toBeDoneIds.split(",");
            List<ProcessAudit> toBeDone = processAuditMapper.getToBeDone(convertType(toBeDoneIdArr));
            if (null != toBeDone && toBeDone.size() > 0) {
                result = new ArrayList<>();
                for(ProcessAudit processAudit : toBeDone) {
                    result.add(processAudit.getId());
                }
            }
        }
        return result;
    }

    private List<Integer> convertType(String[] stringArr) {
        List<Integer> result = null;
        if (null != stringArr && stringArr.length > 0) {
            result = new ArrayList<>();
            for (String str : stringArr) {
                result.add(Integer.parseInt(str));
            }
        }
        return result;
    }

    private String getWarehouse(SysUserDTO user, Integer houseId) {
        String storehouseIds = user.getStorehouseIds();
        String storehouseNames = user.getStorehouseNames();
        if (StringUtils.isNotEmpty(storehouseIds)) {
            String[] storehouseIdArr = storehouseIds.split(",");
            String[] storehouseNameArr = storehouseNames.split(",");
            for (int i = 0; i < storehouseIdArr.length; i++) {
                if (storehouseIdArr[i].equals(houseId + "")) {
                    return storehouseNameArr[i];
                }
            }
        }
        return null;
    }


	@Override
	public void yjcgAudit(String parameter) {
		// TODO Auto-generated method stub

    	com.alibaba.fastjson.JSONObject jsStr = com.alibaba.fastjson.JSONObject.parseObject(parameter);
         String id = jsStr.getString("id");//audit表的每一条数据的id
         Integer auditState = jsStr.getInteger("auditState");//审批的状态（1通过，2不通过）
         String auditTime = jsStr.getString("auditTime");
         String ongoingStep = jsStr.getString("ongoingStep");
         
         //根据id查询数据  最新的数据
         ProcessAudit processAudit = processAuditMapper.selectById(id);
         
         //根据流程id获取 这个流程的所有数据
         QueryWrapper<ProcessAudit> ew5 = new QueryWrapper<>();
         ew5.eq("process_id", processAudit.getProcessId());
         ew5.eq("type", processAudit.getType());
         ew5.isNotNull("from_people");
         ew5.isNotNull("to_people");
         List<ProcessAudit> allPaList = processAuditMapper.selectList(ew5);
         
         //获取审批人
         QueryWrapper<ProcessBasis> ew = new QueryWrapper<>();
         ew.eq("type", processAudit.getType());
 		 List<ProcessBasis> pbList = processBasisMapper.selectList(ew);
 		 List<Integer> idList = new ArrayList<>();
 		 for (ProcessBasis processBasis : pbList) {
			idList.add(processBasis.getId());
		 }
         QueryWrapper<ProcessBasisSon> ew1 = new QueryWrapper<>();
         ew1.eq("depot_id", processAudit.getDepotId());
         ew1.in("zid", idList);
         List<ProcessBasisSon> sonList = processBasisSonMapper.selectList(ew1);
         List<ProcessBasisSon> newSonList = new ArrayList<ProcessBasisSon>();
         
         for (ProcessBasisSon processBasisSon : sonList) {
        	 if(!processBasisSon.getContent().equals(0)){
        		 newSonList.add(processBasisSon);
        	 }
		 }
         

         /**
          * 定义 推送
          */
         SendNoticeVO sendNoticeVO = new SendNoticeVO();
         SysNoticeVO sysNoticeVO = new SysNoticeVO();
         Map<Integer, String> users = new HashMap<Integer, String>();
         Date date = new Date();
         sysNoticeVO.setNoticeTime(date);
         if(processAudit.getType().equals("yjcg")){
        	 sysNoticeVO.setTitle(EnumProcessModel.yjcg.getName());
          	 sysNoticeVO.setNoticeModule("yjcg");
         }else if(processAudit.getType().equals("yjly")){
        	 sysNoticeVO.setTitle(EnumProcessModel.yjly.getName());
          	 sysNoticeVO.setNoticeModule("yjly");
         }else if(processAudit.getType().equals("xzjh")){
        	 sysNoticeVO.setTitle(EnumProcessModel.xzjh.getName());
          	 sysNoticeVO.setNoticeModule("xzjh");
         }else if(processAudit.getType().equals("sswxjh")){
        	 sysNoticeVO.setTitle(EnumProcessModel.sswxjh.getName());
          	 sysNoticeVO.setNoticeModule("sswxjh");
         }else if(processAudit.getType().equals("sswxys")){
        	 sysNoticeVO.setTitle(EnumProcessModel.sswxys.getName());
          	 sysNoticeVO.setNoticeModule("sswxys");
         }else if(processAudit.getType().equals("sbcg")){
        	 sysNoticeVO.setTitle(EnumProcessModel.sbcg.getName());
          	 sysNoticeVO.setNoticeModule("sbcg");
         }else if(processAudit.getType().equals("sbwx")){
        	 sysNoticeVO.setTitle(EnumProcessModel.sbwx.getName());
          	 sysNoticeVO.setNoticeModule("sbwx");
         }else if(processAudit.getType().equals("sbbf")){
        	 sysNoticeVO.setTitle(EnumProcessModel.sbbf.getName());
          	 sysNoticeVO.setNoticeModule("sbbf");
         }
         //根据仓房id获取仓房名称
         String houseName = "";
         if(null != processAudit.getHouseId()){
        	 ResponseEntity<String> forEntity = restTemplate.getForEntity(MyConstant.SYSTEM_WAREHOUSE + processAudit.getHouseId(), String.class);
             if(null != forEntity && null != forEntity.getBody()){
            	 com.alibaba.fastjson.JSONObject jsonObject = JSON.parseObject(forEntity.getBody());
                 BasicsWarehouse ware = com.alibaba.fastjson.JSONObject.toJavaObject(jsonObject, BasicsWarehouse.class);
                 if (null != ware) {
                     sysNoticeVO.setWarehouse(ware.gethName());
                     houseName = ware.gethName();
                 }
             }
         }
         
         //获取申请人的信息
         ResponseEntity<String> userInfos = restTemplate.getForEntity(MyConstant.SYSTEM_USER + processAudit.getApplyPeople(), String.class);
         SysUserPO userInfo = new SysUserPO();
         if(null != userInfos && null != userInfos.getBody()){
        	 com.alibaba.fastjson.JSONObject jsonObjectuser = JSON.parseObject(userInfos.getBody());
             userInfo = com.alibaba.fastjson.JSONObject.toJavaObject(jsonObjectuser, SysUserPO.class);
             //赋值
             if (null != userInfo) {
             	sysNoticeVO.setApplyName(userInfo.getPersonnelName());//公司
                 sysNoticeVO.setOrgName(userInfo.getDepotName());//申请人
                 sysNoticeVO.setApplyDept(userInfo.getDepartmentName());//申请部门
                 sysNoticeVO.setCreateBy(processAudit.getApplyPeople());
             }
         }
        
         
         if(allPaList.size() == newSonList.size()){//最后一个人审批
        	
             //修改最新数据的状态
             if ((int) auditState >= 3) {
                 processAudit.setAuditState(1);
             } else {
                 processAudit.setAuditState(auditState);
             }
             processAudit.setAuditTime(auditTime);
             processAuditMapper.updateById(processAudit);
             //修改第一条数据的状态、进行到哪一步、审批时间(历史的数据)
             /*QueryWrapper<ProcessAudit> ew2 = new QueryWrapper<>();
             ew2.eq("process_id", processAudit.getProcessId());
             ew2.eq("type", processAudit.getType());
             ew2.eq("result", 1);//是第一条记录
             List<ProcessAudit> paList = processAuditMapper.selectList(ew2);*/
             allPaList.get(0).setAuditState(auditState);
             allPaList.get(0).setOngoingStep(ongoingStep);
             processAuditMapper.updateById(allPaList.get(0));
             
             /**
              * 发送通知数据给申请人
              */

             if((int) auditState >= 3 || (int) auditState ==1){
             	sysNoticeVO.setNoticeType(InformModel.TONGGUO.getcode());//申请的时候推送  通知类型：10系统、20待办、30审批通过、40审批不通过、50警告
             	if(null != userInfo){
             		sysNoticeVO.setContent(userInfo.getDepotName()+"-"+houseName+"-"+"审批通过");
             	}
             }else if((int) auditState == 2){
             	sysNoticeVO.setNoticeType(InformModel.BUTONGGUO.getcode());//申请的时候推送  通知类型：10系统、20待办、30审批通过、40审批不通过、50警告
             	if(null != userInfo){
             		sysNoticeVO.setContent(userInfo.getDepotName()+"-"+houseName+"-"+"审批不通过");
             	}
             }
             users.put(processAudit.getApplyPeople(), userInfo.getuName());
        	 
         }else{
        	 Integer toPeople = 0;
        	 for (int i = 0; i < allPaList.size(); i++) {
				if(processAudit.getId().equals(allPaList.get(i).getId())){
					toPeople = newSonList.get(i+1).getContent();
					break;
				}
			}
        	 
        	 processAudit.setAuditState(auditState);
             processAudit.setAuditTime(auditTime);
             processAuditMapper.updateById(processAudit); //更改此条数据的审批状态
             if (auditState.equals(1)) {//1审批通过:,2:审批不通过
                 ProcessAudit processAudit1 = new ProcessAudit();
                 processAudit1.setMainId(processAudit.getMainId());
                 //processAudit1.setAuditState(auditState);
                 //processAudit1.setOperationTime(processAudit.getOperationTime());
                 processAudit1.setType(processAudit.getType());
                 processAudit1.setHouseId(processAudit.getHouseId());
                 processAudit1.setDepotId(processAudit.getDepotId());
                 processAudit1.setFromPeople(processAudit.getToPeople());//当前审批人是下一个审批的提交人
                 processAudit1.setToPeople(toPeople);
                 processAudit1.setResult(0);
                 processAudit1.setAuditState(0);//已提交待审批
                 processAudit1.setApplyPeople(processAudit.getApplyPeople());
                 processAudit1.setProcessId(processAudit.getProcessId());
                 processAudit1.setApplyTime(processAudit.getApplyTime());
                 processAudit1.setOngoingStep(ongoingStep);
                 if(processAudit.getType().equals("yjcg")){
                	 processAudit1.setWorkName(EnumProcessModel.yjcg.getName());
                 }else if(processAudit.getType().equals("yjly")){
                	 processAudit1.setWorkName(EnumProcessModel.yjly.getName());
                 }else if(processAudit.getType().equals("xzjh")){
                	 processAudit1.setWorkName(EnumProcessModel.xzjh.getName());
                 }else if(processAudit.getType().equals("sswxjh")){
                	 processAudit1.setWorkName(EnumProcessModel.sswxjh.getName());
                 }else if(processAudit.getType().equals("sswxys")){
                	 processAudit1.setWorkName(EnumProcessModel.sswxys.getName());
                 }else if(processAudit.getType().equals("sbcg")){
                	 processAudit1.setWorkName(EnumProcessModel.sbcg.getName());
                 }else if(processAudit.getType().equals("sbwx")){
                	 processAudit1.setWorkName(EnumProcessModel.sbwx.getName());
                 }else if(processAudit.getType().equals("sbbf")){
                	 processAudit1.setWorkName(EnumProcessModel.sbbf.getName());
                 }
                 processAuditMapper.insert(processAudit1);
                 
                 /**
                  *  发送通知数据给下一审批人
                  */
                 sysNoticeVO.setContent(userInfo.getDepotName()+"-"+houseName+"-"+"待审批");
                 sysNoticeVO.setNoticeType(InformModel.TONGGUO.getcode());//申请的时候推送  通知类型：10系统、20待办、30审批通过、40审批不通过、50警告
                //获取下一审批人的信息
                 ResponseEntity<String> userInfos1 = restTemplate.getForEntity(MyConstant.SYSTEM_USER + toPeople, String.class);
                 if(null != userInfos1 && null != userInfos1.getBody()){
                	 com.alibaba.fastjson.JSONObject jsonObjectuser1 = JSON.parseObject(userInfos1.getBody());
                     SysUserPO userInfo1 = com.alibaba.fastjson.JSONObject.toJavaObject(jsonObjectuser1, SysUserPO.class);
                     users.put(toPeople, userInfo1.getuName());
                 }
             }else{//不通过 发送数据给申请人  修改第一条数据的状态
            	 allPaList.get(0).setAuditState(auditState);
                 allPaList.get(0).setOngoingStep(ongoingStep);
                 processAuditMapper.updateById(allPaList.get(0));
             	 sysNoticeVO.setContent(userInfo.getDepotName()+"-"+houseName+"-"+"审批不通过");
                 sysNoticeVO.setNoticeType(InformModel.BUTONGGUO.getcode());//申请的时候推送  通知类型：10系统、20待办、30审批通过、40审批不通过、50警告
                 users.put(processAudit.getApplyPeople(), userInfo.getuName());
             }
        	 
         }
         
         sendNoticeVO.setUsers(users);
         sendNoticeVO.setSysNoticeVO(sysNoticeVO);
         ResultView resultView = messageFeign.sendNotice(sendNoticeVO);
         
	}


	/*@Override
	public void drugDetailsAdd(String parameter) throws JSONException {
		// TODO Auto-generated method stub
		
        JSONObject jsStr = new JSONObject(parameter);
        String processId = "";
        if(null != jsStr.optString("processId") && "" != jsStr.optString("processId")){
        	 processId = jsStr.optString("processId");//流程id 用于修改
        }else{
        	 processId = UUID.randomUUID().toString();//生成一个流程id
        }
        
        String type = jsStr.optString("type");//流程类型
        Integer depotId = jsStr.optInt("depotId");//库id
        Integer auditState = jsStr.optInt("auditState");//状态
        JSONArray jsonArray = jsStr.optJSONArray("subList");//子流程数据
        JSONObject row = null;
        for (int i = 0; i < jsonArray.length(); i++) {
            row = jsonArray.getJSONObject(i);
            Integer subData = row.optInt("subData");//子流程数据
            String operationTime = row.optString("operationTime");//子流程的操作时间
            Integer subId = row.optInt("subId");//子流程id
            QueryWrapper<ProcessAudit> ew1 = new QueryWrapper<>();
            ew1.eq("process_id", processId);
            ew1.eq("type", type);
            List<ProcessAudit> list = processAuditMapper.selectList(ew1);
            if(list.size() > 0){//修改
            	QueryWrapper<ProcessAudit> ew2 = new QueryWrapper<>();
            	ew2.eq("process_id", processId);
            	ew2.eq("type", type);
            	ew2.eq("sub_id", subId);
                List<ProcessAudit> list1 = processAuditMapper.selectList(ew2);
                if(list1.size()>0){
                	for (ProcessAudit processAudit : list1) {
                		if(processAudit.getSubId().equals(subId) && !processAudit.getSubData().equals(subData)){
                			//修改
                			processAudit.setSubData(subData);
          				    processAudit.setOperationTime(operationTime);
                            processAuditMapper.updateById(processAudit);
                		}
    				}
                }else{
                	//新增
                    ProcessAudit processAudit1 = new ProcessAudit();
                    processAudit1.setType(type);
                    processAudit1.setSubId(subId);
                    processAudit1.setSubData(subData);
                    processAudit1.setOperationTime(operationTime);
                    processAudit1.setDepotId(depotId);
                    processAudit1.setProcessId(processId);
                    processAuditMapper.insert(processAudit1);
                }
            }else{
            	//第一条数据新增
                ProcessAudit processAudit = new ProcessAudit();
                processAudit.setType(type);
                processAudit.setSubData(subData);
                processAudit.setSubId(subId);
                processAudit.setOperationTime(operationTime);
                processAudit.setDepotId(depotId);
                processAudit.setResult(2);//第一条数据 保存并审批  1是0否 2和流程无关的数据
                processAudit.setProcessId(processId);
                processAudit.setAuditState(auditState);
                Date date = new Date();
                SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm");
                String dateString = formatter.format(date);
                processAudit.setApplyTime(dateString);
                processAuditMapper.insert(processAudit);
            }

        }
        QueryWrapper<ProcessAudit> ew2 = new QueryWrapper<>();
    	ew2.eq("process_id", processId);
    	ew2.eq("type", type);
    	ew2.eq("result", 2);
        List<ProcessAudit> list2 = processAuditMapper.selectList(ew2);
        if(!list2.get(0).getAuditState().equals(auditState)){
        	//修改第一条数据的状态
            list2.get(0).setAuditState(auditState);
    		processAuditMapper.updateById(list2.get(0));
        }
    
	}*/

	@Override
	public void drugDetailsAdd(String parameter) throws JSONException {
		JSONObject jsStr = new JSONObject(parameter);
        String processId = "";
        String receiveProcessId = jsStr.optString("processId");
        if(null != receiveProcessId && !receiveProcessId.equals("")){
        	 processId = receiveProcessId;//流程id 用于修改
        }else{
        	 processId = UUID.randomUUID().toString();//生成一个流程id
        }
        
        String type = jsStr.optString("type");//流程类型
        Integer depotId = jsStr.optInt("depotId");//库id
        Integer auditState = jsStr.optInt("auditState");//状态
        JSONArray jsonArray = jsStr.optJSONArray("subList");//子流程数据
        Integer equipmentId = jsStr.optInt("equipmentId");//状态
        String equipmentNameCode = jsStr.optString("equipmentNameCode");//状态
        JSONObject row = null;
        for (int i = 0; i < jsonArray.length(); i++) {
            row = jsonArray.getJSONObject(i);
            Integer subData = row.optInt("subData");//子流程数据
            String operationTime = row.optString("operationTime");//子流程的操作时间
            Integer subId = row.optInt("subId");//子流程id
            Integer auditId = row.optInt("auditId");//audit表的id
            QueryWrapper<ProcessAudit> ew1 = new QueryWrapper<>();
            ew1.eq("process_id", processId);
            ew1.eq("type", type);
            List<ProcessAudit> list = processAuditMapper.selectList(ew1);
            if(list.size()>0){
            	if(auditId != null && auditId != 0){
                	//修改
                    ProcessAudit processAudit = processAuditMapper.selectById(auditId);
                    if(!processAudit.getSubData().equals(subData)){
                    	processAudit.setSubData(subData);
      				    processAudit.setOperationTime(operationTime);
                        processAuditMapper.updateById(processAudit);
                    }
                	
                }else{
                	//新增
                    ProcessAudit processAudit1 = new ProcessAudit();
                    processAudit1.setType(type);
                    processAudit1.setSubId(subId);
                    processAudit1.setSubData(subData);
                    processAudit1.setOperationTime(operationTime);
                    processAudit1.setDepotId(depotId);
                    processAudit1.setProcessId(processId);
                    processAuditMapper.insert(processAudit1);
                }
            }else{//第一次新增
            	//第一条数据新增
                ProcessAudit processAudit = new ProcessAudit();
                if(type.equals("sbtz")){
                	processAudit.setWorkName(EnumProcessModel.sbtz.getName());
                }else if(type.equals("sbdwgl")){
                	processAudit.setWorkName(EnumProcessModel.sbdwgl.getName());
                }
                processAudit.setType(type);
                processAudit.setSubData(subData);
                processAudit.setSubId(subId);
                processAudit.setOperationTime(operationTime);
                processAudit.setDepotId(depotId);
                processAudit.setResult(2);//第一条数据 保存并审批  1是0否 2和流程无关的数据
                processAudit.setProcessId(processId);
                processAudit.setAuditState(auditState);
                Date date = new Date();
                SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm");
                String dateString = formatter.format(date);
                processAudit.setApplyTime(dateString);
                processAudit.setEquipmentId(equipmentId);
                processAudit.setEquipmentNameCode(equipmentNameCode);
                processAuditMapper.insert(processAudit);
                if(type.equals("sbtz") || type.equals("sbdwgl")){
                	//修改器材库的状态
                	EquipmentStroe entity = new EquipmentStroe();
                	entity.setId(equipmentId);
                	entity.setState(0);
                	quipmentStroeServicee.updateById(entity);
                }
            }
            
        }
        
        QueryWrapper<ProcessAudit> ew2 = new QueryWrapper<>();
    	ew2.eq("process_id", processId);
    	ew2.eq("type", type);
    	ew2.eq("result", 2);
        List<ProcessAudit> list2 = processAuditMapper.selectList(ew2);
        if(!list2.get(0).getAuditState().equals(auditState)){
        	//修改第一条数据的状态
            list2.get(0).setAuditState(auditState);
    		processAuditMapper.updateById(list2.get(0));
        }
        
	}

    @Override
    public List<ProcessAudit> getCurrentMonthData() {
        return processAuditMapper.getCurrentMonthData();
    }
    
    public void createAudit(List<ProcessMain> mainList,List<ProcessAudit> list,int i,HashMap<String, Object> map1,int depot,int ongoingStep) {
        	QueryWrapper<ProcessBasis> ew3 = new QueryWrapper<>();
            ew3.eq("main_id", mainList.get(i).getId());
            List<ProcessBasis> basisList = processBasisMapper.selectList(ew3);
            if(basisList.size()>0){
                List<ProcessBasis> pbList = processBasisService.getBasisByType(basisList.get(0).getType(), null, depot);
                if(pbList.size()>0 && i <= Integer.valueOf(ongoingStep) && list.size()>0){
                   	
                   	//判断是否是通过
                   	boolean flag = list.get(0).getAuditState().equals(2);
                   	//保管员
           			pbList.get(0).setAuditTime(list.get(0).getApplyTime());//保管员的时间为 申请时间
           			pbList.get(0).setContent(list.get(0).getApplyPeople());//保管员为申请人
                   	for (int j = 0; j < pbList.size(); j++) {
                   		    if(j==0)continue;//保管员 不做处理
                   		    //审批人
                   		    ProcessBasis item = pbList.get(j);
                   			if(j-1<=list.size()-1){
                   				// 业务
                   				ProcessAudit audit = list.get(j-1);
                   					item.setAuditTime(audit.getAuditTime());
                       				item.setContent(audit.getToPeople());
                       				if(flag){//不通过
                               			if(j-1==list.size()-1){
                               				item.setAuditState(2);
                               			}else{
                               				item.setAuditState(1);
                               			}
                               		}else{
                               			item.setAuditState(audit.getAuditState());
                               		}
                   			}
           			}
                   	if(pbList.get(1).getAuditState().equals(4) || pbList.get(1).getAuditState().equals(3)){
                   		pbList.get(1).setAuditState(1);
                   	}
                }
                map1.put("audit", pbList);
            }
            
	}
}
