package com.unissoft.ventilation.service.impl;

import com.unissoft.model.ProcessMain;
import com.unissoft.model.ProcessSub;
import com.unissoft.mapper.ProcessMainMapper;
import com.unissoft.mapper.ProcessSubMapper;
import com.unissoft.ventilation.service.ProcessMainService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.google.common.collect.Maps;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author My SunShine
 * @since 2020-12-08
 */
@Service
public class ProcessMainServiceImpl extends ServiceImpl<ProcessMainMapper, ProcessMain> implements ProcessMainService {

	@Autowired
    private ProcessMainMapper processMainMapper;
	
	@Autowired
    private ProcessSubMapper processSubMapper;

	@Override
	public List<Map<String,Object>> getAllProcess(String type) {
		
		List<Map<String,Object>> list = new ArrayList<>();
		QueryWrapper<ProcessMain> ew = new QueryWrapper<>();
		if(type.equals("xzsq") || type.equals("xzjh")){
			ew.eq("type", "xz");
		}else{
			ew.eq("type", type);
		}
		
		List<ProcessMain> mainList = processMainMapper.selectList(ew);
		if(mainList.size()>0){
			for (int i = 0; i < mainList.size(); i++) {
				QueryWrapper<ProcessSub> ew1 = new QueryWrapper<>();
				ew1.eq("zid", mainList.get(i).getId());
				List<ProcessSub> subList = processSubMapper.selectList(ew1);
				HashMap<String, Object> map = Maps.newHashMap();
				map.put("step", mainList.get(i));//主表数据
				map.put("list", subList);//子表数据
				list.add(map);
			}
		}else{
			QueryWrapper<ProcessSub> ew1 = new QueryWrapper<>();
			ew1.eq("type", type);
			List<ProcessSub> subList = processSubMapper.selectList(ew1);
			HashMap<String, Object> map = Maps.newHashMap();
			map.put("list", subList);//子表数据
			list.add(map);
		}
		
		return list;
	}


}
